# -*- coding: utf-8
# $Id: Cruft.py,v 1.9 2003/08/23 12:34:56 berlingo Exp $
#
# Copyright 2001, 2002 by IVA Team and contributors
#
# This file is part of IVA.
#
# IVA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IVA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""Contains class Cruft, which is used as a placeholder for miscellaneous utility functions that many objects need."""

__version__ = "$Revision: 1.9 $"[11:-2]

from AccessControl import ClassSecurityInfo
from urllib import quote
from common import perm_view, perm_edit, perm_manage, perm_add_lo, translate

import re
import common
import time
from common import get_local_roles
import string

class Cruft:
    """Class containing miscellaneous methods that are
    historical baggage, but possible be gotten rid of, or
    at least implemented differently or somewhere else."""
    security = ClassSecurityInfo()
    security.declarePublic('find_URL_of_fle_root')

    def find_URL_of_fle_root(self, REQUEST):
        """Return URL of our FLE installation."""
        import FLE
        from string import rfind
        url = REQUEST.URL1
        obj = self
        while not isinstance(obj, FLE.FLE):
            obj = obj.parent()
            url = url[:rfind(url,'/')]
        return url

    def find_URL_of_user_info(self, REQUEST):
        """Return URL of UserInfo."""
        import UserInfo
        from string import rfind
        url = REQUEST.URL1
        obj = self
        while not isinstance(obj, UserInfo.UserInfo):
            obj = obj.parent()
            url = url[:rfind(url,'/')]
        return url


    security.declarePublic('find_URL_of_webtop')
    def find_URL_of_webtop(self, REQUEST):
        """Return URL of Webtop."""
        import Webtop
        from string import rfind
        url = REQUEST.URL1
        obj = self
        while not isinstance(obj, Webtop.Webtop):
            obj = obj.parent()
            url = url[:rfind(url,'/')]
        return url

    security.declarePublic('find_URL_of_group_folder')
    def find_URL_of_group_folder(self, REQUEST):
        """Return URL of toplevel group folder or group folder proxy."""
        import GroupFolder
        import GroupFolderProxy
        from string import rfind
        url = REQUEST.URL1
        obj = self
        while 1:
            if isinstance(obj, GroupFolderProxy.GroupFolderProxy):
                return url
            if isinstance(obj, GroupFolder.GroupFolder):
                return url
            obj = obj.parent()
            url = url[:rfind(url,'/')]
        return url

    security.declarePublic('find_URL_of_thread_start_node')
    def find_URL_of_thread_start_node(self, REQUEST):
        """Return URL of starting note."""
        import CourseContext
        from string import rfind

        url = REQUEST.URL1
        obj = self
        while not isinstance(obj.parent(), CourseContext.CourseContext):
            obj = obj.parent()
            url = url[:rfind(url,'/')]
        return url

    security.declarePublic('find_URL_of_course')
    def find_URL_of_course(self, REQUEST):
        """Return URL of starting note."""
        obj = self
        while not obj.meta_type == 'Course':
            obj = obj.parent()
        return obj.absolute_url()

    security.declarePublic('find_URL_of_course_context')
    def find_URL_of_course_context(self, REQUEST):
        """Return URL of starting note."""
        import CourseContext
        from string import rfind

        url = REQUEST.URL1
        obj = self
        while not isinstance(obj, CourseContext.CourseContext):
            obj = obj.parent()
            url = url[:rfind(url,'/')]
        return url

    security.declarePublic('is_student')
    def is_student(self, REQUEST,nr=None, uname=''):
	""" is give user is student in given course """
	splitter = '/'
	if splitter not in REQUEST.PATH_TRANSLATED:
            splitter = '\\'
	if nr is None:
		nr = self.jooksva_kursuse_nr(REQUEST,uname)
		ic = string.rfind(REQUEST.PATH_TRANSLATED, 'fle_users')
		url = REQUEST.PATH_TRANSLATED
		if ic == -1:
			nr = self.fle_root().courses.get_course_id_from_req(REQUEST)
		else:
			i = ic
			plst = filter(lambda x:x, string.split(url[i:], splitter))
			nr = plst[3][1:]
	if not hasattr(self.fle_root().courses, str(nr)):
		return 0
	checkname = str(REQUEST.AUTHENTICATED_USER)
	if 'Student' in get_local_roles(getattr(self.fle_root().courses, nr),checkname):
		return 1
	try:
		fm = getattr(self.fle_root().fle_users, checkname)
		if fm.has_any_role(('IVAAdmin','Manager')):
			return 1
	except:
		return 0
	
	return 0

    security.declarePublic('kas_opetaja')
    def kas_opetaja(self,REQUEST,nr=None,uname=''):
	""" If user is teacher. Additional role checks """
	if nr is None:
		nr = self.jooksva_kursuse_nr(REQUEST,uname)
	if not hasattr(self.fle_root().courses, str(nr)):
		return 0
	if uname:
		pass
		#checkname = uname
	else:
		pass
	checkname = str(REQUEST.AUTHENTICATED_USER)
	if checkname in getattr(self.fle_root().courses, nr).get_teachers():
		return 1
	#try:
	#XXX: Should we put try except here?
	if 1==1:
		fm = getattr(self.fle_root().fle_users, checkname)
		#XXX: this sucks?
		if fm.has_any_role(('IVAAdmin','Manager')):
			return 1
	return 0

    security.declarePublic('jooksva_kursuse_nimi')
    def jooksva_kursuse_nimi(self,REQUEST,uname=''):
        """ jooksva kursuse nimi """
        nr = self.jooksva_kursuse_nr(REQUEST,uname)
	try:
                return str(getattr(self.fle_root().courses, nr).get_name())
	except:
		return "course not selected"

    security.declarePublic('jooksva_kursuse_nr')
    def jooksva_kursuse_nr(self,REQUEST,uname=''):
        """ jooksva kursuse number """;
	try:
		if uname:
			return str(getattr(self.fle_root().fle_users, uname).get_jooksev_kursus())
		else:
		        return str(getattr(self.fle_root().fle_users, self.get_current_user(REQUEST)).get_jooksev_kursus())
	except:
		return 0


    security.declarePublic('get_current_user')
    def get_current_user(self, REQUEST):
        """Extract current user's name from the REQUEST object."""
        if hasattr(REQUEST, 'kasutajanimi'):
          return REQUEST.kasutajanimi
        else:
          return str(REQUEST.AUTHENTICATED_USER)
        
    def salvestaKasutajanimi(self, REQUEST, nimi):
        """Kuna Python ei suuda alati AUTHENTICATED_USERit korralikult välja lugeda,
           siis jäetakse nimi DTMLi kaudu meelde."""
        REQUEST.kasutajanimi=nimi
        return self.get_current_user(REQUEST)

    security.declarePublic('urlquote')
    def urlquote(self, text):
        """urlquote given text."""
        return quote(text)

    def get_url_to_object(self,obj):
        # Make a list of parents without the Application object
        # (from obj to FLE)
	#XXX: remove me!
	return obj.absolute_url()+'/'
        objs = obj.aq_inner.aq_chain[:-1]
        objs.reverse()
        path='/'.join([x.getId() for x in objs])+'/'
        return path

    def get_object_of_url(self,url,base,remove_last=1):
	#XXX: broken for VirtualHostMonster!
        path=url.split('/')
	if remove_last:
	        path.pop() # remove last entry
        path.reverse()
        if path[-1]=='http:':  # remove protocol
            path.pop()
            path.pop()
        path.pop() # remove first (root) entry
        obj = base.fle_root()
        #obj = base.getPhysicalRoot()
        try:
            while path:
                oname=path.pop()
                obj=getattr(obj,oname).__of__(obj)
            return obj
        except:
            #raise 'Internal link error, object not found',str(obj)+' - '+oname
            return None

    def kasutajaURList(self, REQUEST):
       "Kasutajanimi"
       nimi=self.kasutajaNimi(REQUEST)
       if nimi=="":
         return nimi
       if nimi==str(REQUEST.AUTHENTICATED_USER):
         return ""
       return "&gt; " + "<a href='"+self.find_URL_of_fle_root(REQUEST)+"/fle_users/"+nimi+"/webtop/c"+self.jooksva_kursuse_nr(self, REQUEST)+"'>"+nimi+"</a>"

    def algusURList(self, REQUEST, osa):
      "URL soovitud loiguni"
      x=REQUEST.URL0
      if x.find(osa)==-1:
        return ""
      return x[:x.find(osa)+len(osa)]
      
    def kasLopeb(self, tekst, otsitav):
      "jah/ei"
#      return tekst+" ja " + otsitav
      return tekst.endswith(otsitav)

    def myOwnWebtop(self, REQUEST):
      "jah/ei"
      return self.kasutajaNimi(REQUEST)==str(REQUEST.AUTHENTICATED_USER)

    def kasutajaNimi(self, REQUEST):
       "nimi"
       aadress=REQUEST.URL0
       nr=aadress.find('fle_users')
       if nr==-1:
         return ""
       ots=aadress.find('/', nr+10)       
       nimi=aadress[nr+10:ots]
       nimi = re.sub('%20', ' ',nimi)
       return nimi

    security.declarePublic('leiaKasutaja')
    def leiaKasutaja(self, REQUEST):
       "kasutaja objekt"
       nimi=self.kasutajaNimi(REQUEST)
       if hasattr(self.fle_root().fle_users, nimi):
          return getattr(self.fle_root().fle_users, nimi)
       return None

    def jooksevKasutaja(self, REQUEST):
       "Kasutajainfo objekt sisseloginud kasutaja kohta"
       return getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER))
       
    def leheAvamisToimingud(self, REQUEST,uname=None):
	"Tegevused iga lehe avamisel"
	try:
		self.seaKasutajaKeel(REQUEST)
		self.jooksevKasutaja(REQUEST).update_active(self.jooksva_kursuse_nr(REQUEST,uname))
		self.lisaSyndmus(REQUEST, "lehtiAvatud",kasutajanimi=uname)
		self.kontrolli_kursuse_kaust(self, REQUEST)          
	except:
		pass
	return "tehtud"

    def ajaMuutmisElemendid(self, elemendinimi, aeg=-1):
     "Valikute kogum"
     import YlTest
     from YlTest import LahendusLuba
     from types import StringType
     abi=LahendusLuba()
     if type(aeg)==StringType: aeg=float(aeg)
     if aeg==-1:aeg=time.time()
     m=time.localtime(aeg)
     tulemus=abi.looValik(elemendinimi+"Aasta", m[0]-5, m[0]+10, m[0])
     tulemus=tulemus+"-"+\
             abi.looValik(elemendinimi+"Kuu", 1, 12, m[1])
     tulemus=tulemus+"-"+\
             abi.looValik(elemendinimi+"Paev", 1, 31, m[2])
     tulemus=tulemus+" &nbsp; "+\
             abi.looValik(elemendinimi+"Tund", 0, 23, m[3])
     tulemus=tulemus+":"+\
             abi.looValik(elemendinimi+"Minut", 0, 59, m[4], samm=5)
     return tulemus

    def seaKasutajaKeel(self, REQUEST):
       "Kasutja keele määramine"
       if hasattr(REQUEST, 'HTTP_ACCEPT_LANGUAGE'):
         keeletekst=REQUEST['HTTP_ACCEPT_LANGUAGE']
         keeled=keeletekst.split(",")
         kasutaja=self.jooksevKasutaja(REQUEST)
         if not kasutaja.kasKeelBrauserist():
           return "Vahetusesoov puudub"
         for x in keeled:
           if x=='et': x='et_ee'
           if x in ('et_ee', 'en'):
             kasutaja.set_language(x)
             return "Uus keel "+x
       return "Keel puudub"

    def set_undefined_page(self, message, REQUEST):
        """Set REQUEST.RESPONSE.redirect, so that we go to undefined page
        and give an explanation."""
        message = common.quote_html_hack(message)
        REQUEST.RESPONSE.redirect("undefined_page?explanation=%s" % message)

    security.declarePublic('to_str_list')
    # Using eval would be simpler and more general, but
    # we want to be paranoid.
    def to_str_list(self, s):
        """Reverse str representation of list of strings back to list."""
        return [x.strip() for x in s[1:-1].replace("'", "").split(',')]

    def webtopi_sygavus(self,REQUEST):
	""" to be removed. For wiki only"""
	x = REQUEST.URL0.split("/")
	if x[-3] == 'webtop':
		return 1
	return 0

    def kasutajaasukoht(self, REQUEST,url=''):
       "Kasutaja asukoht"
       if url:
	       x = url
       else:
	       x = REQUEST.URL0
       if x.find('manage')>0: return "Haldus"
       if x.find('WelCome')>0: return "Raamaturiiul" #Course ZWiki
       if x.find('assignmentGrading')>0: return "Veebilaud"
       if x.find('createMail')>0 or x.find('edit_user_form')>0 or x.find('show_user_info')>0: return 'Organizer'
       if x.find('kalendriAasta')>0 or x.find('organizer')>0: return 'Organizer'
       if x.find('course_info_user')>0: return "Veebilaud"
       if x.find('course_index')>0 or x.find('course_info')>0: return 'Raamaturiiul'
       if x.find('tootubade_leht')>0 or x.find('workshop_')>0: return "Tootuba"
       if x.find('/courses/')>0:
	       if x.find('/testihaldus')>0 or x.find('/courses/index_html')>0 or self.kas_haldus(REQUEST,x): return "Haldus"
	       if not x.find('/gf/')>0 and x.find('/testid/')>0: return "Haldus"
	       if x.find('import_form_handler2')>0: return "Haldus"
	       if not x.find('/gf/')>0: return "Tootuba"
       if x.find('/fle_users/')>0 and x.find('/webtop/')>0: return "Veebilaud"

       if self.kas_haldus(REQUEST, x) or x.find('ootajateLoetelu')>0:
          return 'Haldus'
       else:
          return 'Raamaturiiul'
 
    def sisegrupiNimi(self, REQUEST):
      "URList loetud grupi nimi"
      x=REQUEST.URL0
      if x.find('/subgroups/')>0:
        algus=x.find('/subgroups/')
        ots=x.find('/', algus+11)
        if ots==-1:
          tulemus=x[algus+11:]
        else:
          tulemus=x[algus+11:ots]
	if tulemus == 'wt_index_html':
		return "listing"
        return tulemus
      else:
        return ""

    security.declarePublic('kas_haldus')
    def kas_haldus(self, REQUEST, veebiurl):
       "kas sobib halduseks"
       if re.match(".*/courses/[0-9]+/syndmused", veebiurl):
         if self.kas_opetaja(self, REQUEST): return 1
         else: return 0
       laused=(
         ".*haldusleht",
         ".*testihaldus",
         ".*muuda_vorm",
         ".*kysimuse_vorm",
         ".*add_course_form",
         ".*sisegrupihaldus",
         ".*courses/index_html",
         ".*ylesandedMuutmisTabelina",
         ".*ylesanneteTyypideLoetelu",
         ".*pealkirjaMuutmisVormHTML",
         ".*muutmisVorm",
         ".*lubadeViited",
         ".*koigiLuba",
         ".*isikuLubadeLisamisVorm",
         ".*grupiLubadeLisamisVorm",
         ".*/filtreerimisvorm2",
         ".*/kasutajateTulemused",
         ".*/typesets",
         ".*/lahendusteStatistika",
         ".*/kodutood.*",
	 ".*/manage.*",	
	 ".*qtCatalog.*",
	 ".*testideImport.*",
         #".*",         
       )
       leitud=0
       x=veebiurl
       for lause in laused:
         if re.match(lause, x):
           leitud=1
       return leitud

    security.declarePublic('kas_kasutaja_haldus')
    def kas_kasutaja_haldus(self, veebiurl):
       "kas sobib halduseks"
       laused=(
         ".*kasutajate_haldamise_vorm",         
         ".*kasutajateLisamisFailiVorm",         
         ".*kasutajaLehelt1",         
         ".*kasutajadFailist2",         
         ".*kasutajadFailist1",         
         ".*erialadeHalduseVorm",         
         ".*/kasutajaotsing",
         ".*/kasutajateKustutus.*",
         #".*",         
       )
       leitud=0
       x=veebiurl
       for lause in laused:
         if re.match(lause, x):
           leitud=1
       return leitud
       
    def lisaSyndmus(self, REQUEST, syndmus, kasutajanimi=None,  lisaparameeter=None):
      "Kasutaja statistika lisamine"
      if(REQUEST == None):
        return "REQUEST puudub"
      if kasutajanimi is None:
        kasutajanimi=self.get_current_user(REQUEST)
      k=getattr(self.fle_root().fle_users, kasutajanimi).webtop
      kv=getattr(k, 'c'+str(self.fle_root().jooksva_kursuse_nr(REQUEST,kasutajanimi)))
      if not hasattr(kv.aq_inner, 'toimingud'):
        kv.aq_inner.toimingud={}
      if kv.aq_inner.toimingud.has_key(syndmus):
        kv.aq_inner.toimingud[syndmus]=kv.aq_inner.toimingud[syndmus]+1
      else:
        kv.aq_inner.toimingud[syndmus]=1
      kv.aq_inner.toimingud=kv.aq_inner.toimingud #kinnistus Zope tarvis
      return kv.aq_inner.toimingud        

    security.declareProtected(perm_view, 'getUserStatistics')
    def getUserStatistics(self):
	try:
		return getattr(self.aq_self, 'toimingud')
	except AttributeError:
		return None
	
    def kasutajaTestiTulemused(self, REQUEST, kasutaja, knr):
      "Kasutaja kõikide testide lühikokkuvõte"
      kc=getattr(kasutaja.webtop, 'c'+str(knr))
      knr = getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).get_jooksev_kursus()
      tmp = getattr(self.fle_root().courses, str(knr))
      if not hasattr(kc, 'testivastused'):
        return ""
      kv=kc.testivastused
      tulemus=""
      for test in kv.objectValues():
       try:
           p_test = getattr(tmp.testid, str(test.id))
           tulemus=tulemus+p_test.pealkiri+": "
       except:
           p_test = None
           tulemus=tulemus+test.id+": "
       try:
        for variant in test.objectValues():
          if p_test != None:
             if p_test.kasLubatudLahendusiVaadata(REQUEST):
                tulemus=tulemus+" <a href='"+variant.absolute_url()+"'>"
             tulemus+=variant.punktiArvutusLyhiHTML(REQUEST)
             if p_test.kasLubatudLahendusiVaadata(REQUEST):
                tulemus+="</a>;&nbsp;"
             else:
                tulemus += ";&nbsp;"
#                tulemus=tulemus+" <a href='"+variant.absolute_url()+"'>"+variant.punktiArvutusLyhiHTML(REQUEST)+"</a>"
        tulemus=tulemus+"<br />"
       except:
         pass
      return tulemus
      
    def kysiURLParameeter(self, REQUEST, parameeter):
      "Kui pole, siis tühi"
      if hasattr(REQUEST, parameeter):
        return REQUEST[parameeter]
      return ""      
      
    def filtreeriKasutajad(self, REQUEST, loetelu, enimi="", pnimi="", knimi="", org="-1"):
      "Kasutajate filtreerimine"
      tulemus=[]
      try:
        org=int(org)
      except:
        org=-1
      for kasutaja in loetelu:
        korras=1
        if not kasutaja.get_first_name().lower().startswith(enimi.lower()): korras=0
        if not kasutaja.get_last_name().lower().startswith(pnimi.lower()): korras=0
        if not kasutaja.get_uname().startswith(knimi.lower()): korras=0
        if org!=-1:
          if not kasutaja.get_organization().lower().startswith(self.fle_root().fle_users.getAffiliations()[int(org)].lower()): korras=0
        if korras:
          tulemus.append(kasutaja)
      return tulemus
      
    def zwiki_export(self,REQUEST,level,wiki_id):
	""" zwiki manage form handler """
	from ImportExportIMS import Kirjutus
	from ImportExportIMS import kirjutaYldM
	import tempfile, os

	failinimi = tempfile.mktemp()
	if not level: level=99999
#	number = self.get_course_id_from_req(REQUEST)
	number = 0
#	nr = self.get_id()
#	try:
#		number = int(nr)
#	except:
#		number = int(nr[1:])

	yld = kirjutaYldM()
	yld.kirjutaYldmanifest(number,'WIKI',base=str(number)+'/')
	yld.lisaFaili(failinimi)

	k = Kirjutus(self.fle_root(), number)
	k.looKursuseFail(0)
	wikikoht=''
	try:
		wikikoht = getattr(self,wiki_id)
	except:
		pass
	if wikikoht:
		k.kirjutaWiki(wikikoht,'ZWiki',wikikoht.aq_inner.get_name(),wikikoht.wikiKaustEsimeneLeht(),palju=level)

#	else:
#		k.kirjutaKasutajaWiki((self.get_user_info(str(REQUEST.AUTHENTICATED_USER)),))

	k.pakiKursusFaili(failinimi)

	file = open(failinimi,"rb")
	export_data=file.read()
	file.close()

	os.remove(failinimi)
	REQUEST.RESPONSE.setHeader('Content-disposition','attachment; filename=zwikiexport.zip')
	REQUEST.RESPONSE.setHeader('content-type','application/zip')
	return export_data

    security.declareProtected(perm_view, 'saadaEmail')
    def saadaEmail(self,tomail,subject,message,saatja=''):
	""" proovime saata kirja """
	p_saatja = ''
	if saatja:
		p_saatja = saatja
	if hasattr(self,'MFROM') and not p_saatja:
		p_saatja = self.MFROM
	if not p_saatja:
		return 0
	try:
		mailhost = self.MailHost
        	mailhost.send(message,tomail,p_saatja,subject,encode='quoted-printable')
		return 1 
	except:
		return 0

    def editSearchResultsURL(self,indexUrl):
       "Otsingu tulemusele vastav URL"
       url=''
       nr=string.find( indexUrl, 'fle_users')
       if(nr != -1):
           url=self.fle_root().absolute_url()+'/'+indexUrl[nr:len(indexUrl)] 
       else:
           nr=string.find( indexUrl, 'courses')
           if(nr != -1):
              url=self.fle_root().absolute_url()+'/'+indexUrl[nr:len(indexUrl)] 
       return url
 
    def leivaPuru(self,REQUEST):
	""" leivapuru """
	#XXX:maybe we don't need this!
	if REQUEST.URL0.find('kirjad')>0: return REQUEST['L_ic_mailbox']
	if self.kasLopeb(REQUEST.URL1, 'webtop/c'+str(self.jooksva_kursuse_nr(self, REQUEST))):
		return 'portfolio' 
	else:
		return "<a href=\""+\
		self.algusURList(REQUEST, 'webtop/c'+str(self.jooksva_kursuse_nr(self, REQUEST)))+"\">"+'portfolio'+"</a>"

	return "kala"

    def numberToText(self, REQUEST, arv):
        "Asendab punkti komaga, kui see vajalik"
        tekst=str(arv)
        eraldaja=translate(self, "decimal_separator", target=self.giveLanguage(REQUEST))
        tekst=tekst.replace(".", eraldaja)
        return tekst

    def giveLanguage(self, REQUEST):
	""" gives user language """
	prev_lang = REQUEST.HTTP_ACCEPT_LANGUAGE
	try:
		if getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).kasKeelBrauserist():
                    language = prev_lang
                else:
                    language = getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).get_language()
	except:
		language = prev_lang
	#XXX: let's see if this works..
	if language not in self.get_languages():
		language = prev_lang
	if language == 'et_ee':
		language = 'et'
	return language


    def firstAndLast(self,uname='',req=None):
        """ Give object author's first and last name """
	if not uname and not req:
		return ""
        if not uname:
		abc = req.AUTHENTICATED_USER
        else:
                abc = uname
        try:
                ui = self.fle_users.get_user_info(str(abc))
                if ui.get_first_name()=='' and ui.get_last_name()=='':
                        nimi = abc
                else:
                        nimi = ui.get_first_name()+" "+ui.get_last_name()
        except:
                nimi = uname
        return nimi

    def is_courseContext(self):
	return 0


# EOF
