# -*- coding: utf-8
import zipfile
import xml.dom.minidom
import xml.sax
from xml.dom.minidom import Document
import string
from xml.sax import saxutils
from xml.dom.ext.reader import Sax2
from ImportExport import Counter, DataTable, to_utf8, Exporter, Dump
from common import FakeRequest, FakeUpload
from xml.dom import implementation
from xml.dom import EMPTY_NAMESPACE, XML_NAMESPACE
from xml.dom.ext import PrettyPrint
from Products.ZWiki.ZWikiPage import ZWikiPage
from types import UnicodeType
from input_checks import strip_non_xml
import OFS.Image
import types
import re, time


class User_export:
    def __init__(self):
	self.binarydata = DataTable()
	self.sisegrupid = []
	doctype = implementation.createDocumentType("enterprise", "http://www.htk.tpu.ee/%7Evahur/ims_epv1p1.dtd", "http://www.htk.tpu.ee/%7Evahur/ims_epv1p1.dtd")
	self.user = implementation.createDocument(EMPTY_NAMESPACE, "enterprise", doctype)
	self.userelem = self.user.documentElement
	prop = self.user.createElement('properties')
	self.userelem.appendChild(prop)
	source = self.user.createElement('datasource')
	source_data = self.user.createTextNode('IVA')
	source.appendChild(source_data)
	prop.appendChild(source)
	datetime = self.user.createElement('datetime')
	datetime_data = self.user.createTextNode('kuupaev')
	datetime.appendChild(datetime_data)
	prop.appendChild(datetime)

    def kirjutaKasutaja(self,kasutaja,kursus=''):
	person = self.user.createElement('person')
	self.userelem.appendChild(person)

	sourcedid = self.user.createElement('sourcedid')
	person.appendChild(sourcedid)
	source = self.user.createElement('source')
	source_data = self.user.createTextNode('IVA')
	source.appendChild(source_data)
	sourcedid.appendChild(source)
	id = self.user.createElement('id')
	id_data = self.user.createTextNode(kasutaja.get_uname())
	id.appendChild(id_data)
	sourcedid.appendChild(id)
	
	userid = self.user.createElement('userid')
	try:
		userid.setAttribute('password',kasutaja.getPassword())
	except:
		userid.setAttribute('password','nipitiri')
	userid_name = self.user.createTextNode(kasutaja.get_uname())
	userid.appendChild(userid_name)
	person.appendChild(userid)

	name = self.user.createElement('name')
	person.appendChild(name)
	fn = self.user.createElement('fn')
	fn_data = self.user.createTextNode(kasutaja.get_first_name()+' '+kasutaja.get_last_name())
	fn.appendChild(fn_data)
	name.appendChild(fn)
	n = self.user.createElement('n')
	name.appendChild(n)
	family = self.user.createElement('family')
	family_data = self.user.createTextNode(kasutaja.get_last_name())
	family.appendChild(family_data)
	n.appendChild(family)
	given = self.user.createElement('given')
	given_data = self.user.createTextNode(kasutaja.get_first_name())
	given.appendChild(given_data)
	n.appendChild(given)
	partname = self.user.createElement('partname')
	partname.setAttribute('partnametype','First')
	partname.setAttribute('lang',kasutaja.get_language())
	partname_data = self.user.createTextNode(kasutaja.get_first_name())
	partname.appendChild(partname_data)
	n.appendChild(partname)

	demogr = self.user.createElement('demographics')
	email = self.user.createElement('email')
	email_data = self.user.createTextNode(kasutaja.get_email())
	email.appendChild(email_data)
	person.appendChild(email)

	url = self.user.createElement('url')
	url_data = self.user.createTextNode(kasutaja.get_homepage())
	url.appendChild(url_data)
	person.appendChild(url)
	tel_t = self.user.createElement('tel')
	tel_t.setAttribute('teltype','Voice')
	tel_t_data = self.user.createTextNode(kasutaja.get_phone())
	tel_t.appendChild(tel_t_data)
	person.appendChild(tel_t)
	tel_gsm = self.user.createElement('tel')
	tel_gsm.setAttribute('teltype','Mobile')
	tel_gsm_data = self.user.createTextNode(kasutaja.get_gsm())
	tel_gsm.appendChild(tel_gsm_data)
	person.appendChild(tel_gsm)

	adr = self.user.createElement('adr')
	person.appendChild(adr)
	extadd = self.user.createElement('extadd')
	extadd_data = self.user.createTextNode(kasutaja.get_address2())
	extadd.appendChild(extadd_data)
	adr.appendChild(extadd)
	street = self.user.createElement('street')
	street_data = self.user.createTextNode(kasutaja.get_address1())
	street.appendChild(street_data)
	adr.appendChild(street)
	locality = self.user.createElement('locality')
	locality_data = self.user.createTextNode(kasutaja.get_city())
	locality.appendChild(locality_data)
	adr.appendChild(locality)
	country = self.user.createElement('country')
	country_data = self.user.createTextNode(kasutaja.get_country())
	country.appendChild(country_data)
	adr.appendChild(country)

	try:
		if kasutaja.get_photo():
			photo = self.user.createElement('photo')
			photo.setAttribute('imgtype',kasutaja.get_photo_type())
			extref = self.user.createElement('extref')
			photo_name = self.binarydata.storeData(kasutaja.get_photo(),'user')
			extref_data = self.user.createTextNode(photo_name)
			extref.appendChild(extref_data)
			photo.appendChild(extref)
			person.appendChild(photo)
	except:
		pass

	systemrole = self.user.createElement('systemrole')
	kas_admin =  kasutaja.getRoles()
	if 'Manager' in kas_admin:
		systemrole.setAttribute('systemroletype','SysAdmin')
	else:
		systemrole.setAttribute('systemroletype','User')
	person.appendChild(systemrole)
	try:
		instrole = self.user.createElement('institutionrole')
		instrole.setAttribute('primaryrole','No')
		instrole.setAttribute('institutionroletype','Learner')
		for abc in kursus.get_local_roles():
			if abc[0]==kasutaja.get_uname() and 'Teacher' in abc[1]:
				instrole.setAttribute('institutionroletype','Instructor')
		person.appendChild(instrole)
	except:
		pass

	extension = self.user.createElement('extension')
	person.appendChild(extension)
	org = self.user.createElement('org')
	extension.appendChild(org)
	orgname = self.user.createElement('orgname')
	orgname_data = self.user.createTextNode(kasutaja.get_organization())
	orgname.appendChild(orgname_data)
	org.appendChild(orgname)

	comment = self.user.createElement('comments')
	comment_data = self.user.createTextNode(kasutaja.get_background())
	comment.appendChild(comment_data)
	extension.appendChild(comment)
	desc = self.user.createElement('description')
	extension.appendChild(desc)
	short = self.user.createElement('short')
	short_data = self.user.createTextNode(kasutaja.get_personal_interests())
	short.appendChild(short_data)
	desc.appendChild(short)
	long = self.user.createElement('long')
	long_data = self.user.createTextNode(kasutaja.get_professional_interests())
	long.appendChild(long_data)
	desc.appendChild(long)
	label = self.user.createElement('label')
	label_data = self.user.createTextNode(kasutaja.get_quote())
	label.appendChild(label_data)
	extension.appendChild(label)

	return "valmis"


    def pakiFaili(self,kursusega,failinimi="userexport.zip"):
        "Pakitakse kasutajad faili"
	if kursusega=="/":
		kursusega = ''
        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        PrettyPrint(self.user,stream=dump)
        zip.writestr(zipfile.ZipInfo(kursusega+"users.xml"),dump.getdata())
        for name in self.binarydata.names:
            zip.writestr(
                zipfile.ZipInfo(kursusega+name),
                str(self.binarydata.getData(name)))
        zip.close()

    def kirjutaKursusGrupina(self,kursus):
	# Kirjutab grupi mis omab kursuse funktsiooni. Kik kes selles grupis on
	# student vi teacher
	krupp = self.user.createElement('group')

	krupp_s = self.user.createElement('sourcedid')
	krupp_source = self.user.createElement('source')
	krupp_source_data = self.user.createTextNode('IVA')
	krupp_source.appendChild(krupp_source_data)
	krupp_s.appendChild(krupp_source)
	krupp_id = self.user.createElement('id')
	krupp_id_data = self.user.createTextNode(kursus.get_name())
	krupp_id.appendChild(krupp_id_data)
	krupp_s.appendChild(krupp_id)
	krupp.appendChild(krupp_s)

	krupp_type = self.user.createElement('grouptype')
	type_value = self.user.createElement('typevalue')
	type_value.setAttribute('level','1')
	krupp_type.appendChild(type_value)
	krupp.appendChild(krupp_type)

	description = self.user.createElement('description')
	desc_short = self.user.createElement('short')
	desc_short_data = self.user.createTextNode(kursus.kysiTekst())
	desc_short.appendChild(desc_short_data)
	description.appendChild(desc_short)
	desc_long = self.user.createElement('long')
	desc_long_data = self.user.createTextNode(kursus.get_methods())
	desc_long.appendChild(desc_long_data)
	description.appendChild(desc_long)
	desc_full = self.user.createElement('full')
	desc_full_data = self.user.createTextNode(kursus.get_description())
	desc_full.appendChild(desc_long_data)
	description.appendChild(desc_full)
	krupp.appendChild(description)

	org = self.user.createElement('org')
	orgname = self.user.createElement('orgname')
	orgname_data = self.user.createTextNode(kursus.get_name())
	orgname.appendChild(orgname_data)
	org.appendChild(orgname)
	orgunit = self.user.createElement('orgunit')
	orgunit_data = self.user.createTextNode(kursus.get_organisation())
	orgunit.appendChild(orgunit_data)
	org.appendChild(orgunit)
	krupp.appendChild(org)

	enrollcontrol = self.user.createElement('enrollcontrol')
	enroll_accept = self.user.createElement('enrollaccept')
	enroll_allowed = self.user.createElement('enrollallowed')
	try:
		if str(kursus.kysiStaatus()) == str('0') or int(kursus.kysiStaatus())>1:
			enroll_accept_data = self.user.createTextNode('0')
		else:
			enroll_accept_data = self.user.createTextNode('1')
	except:
		enroll_accept_data = self.user.createTextNode('0')
	enroll_allowed_data = self.user.createTextNode('1')
	enroll_accept.appendChild(enroll_accept_data)
	enroll_allowed.appendChild(enroll_allowed_data)
	enrollcontrol.appendChild(enroll_accept)
	enrollcontrol.appendChild(enroll_allowed)
	krupp.appendChild(enrollcontrol)
		
	self.userelem.appendChild(krupp)

    def kirjutaSisegrupid(self,kursus,sisegrupp):
	krupp = self.user.createElement('group')
	sourcedid = self.user.createElement('sourcedid')
	source = self.user.createElement('source')
	source_data = self.user.createTextNode('IVA')
	source.appendChild(source_data)
	sourcedid.appendChild(source)
	id = self.user.createElement('id')
#	id_data = self.user.createTextNode(str(kursus.get_id())+":"+str(sisegrupp.id))
	id_data = self.user.createTextNode(str(sisegrupp.id))
	id.appendChild(id_data)
	sourcedid.appendChild(id)
	krupp.appendChild(sourcedid)

	description = self.user.createElement('description')
	short = self.user.createElement('short')
	short_data = self.user.createTextNode(sisegrupp.title)
	short.appendChild(short_data)
	description.appendChild(short)
	krupp.appendChild(description)

	#relationship
	relationship = self.user.createElement('relationship')
	relationship.setAttribute('relation','2')

        sourcedid = self.user.createElement('sourcedid')
        source = self.user.createElement('source')
        source_data = self.user.createTextNode('IVA')
        source.appendChild(source_data)
        sourcedid.appendChild(source)
        id = self.user.createElement('id')
        id_data = self.user.createTextNode(kursus.get_name())
        id.appendChild(id_data)
        sourcedid.appendChild(id)
	relationship.appendChild(sourcedid)

	label = self.user.createElement('label')
	label_data = self.user.createTextNode('Course sub-group')
	label.appendChild(label_data)
	relationship.appendChild(label)
	krupp.appendChild(relationship)

        self.userelem.appendChild(krupp)

        return

    def kirjutaMembership(self,kogum,tyyp='kursus'):
	# write <membership> tag
	if tyyp == 'kursus':
		sortsu_id = kogum.get_name()
		kasutajad = kogum.get_all_users()
		comment_data = self.user.createTextNode('KURSUS')
	else:
		sortsu_id = kogum.id
		kasutajad = kogum.kasutajad_sisegrupis(sortsu_id,objektina=1)
		comment_data = self.user.createTextNode('SISEGRUPP')

	membership = self.user.createElement('membership')

	comment = self.user.createElement('comments')
	comment.appendChild(comment_data)
	membership.appendChild(comment)

        sourcedid = self.user.createElement('sourcedid')
        source = self.user.createElement('source')
        source_data = self.user.createTextNode('IVA')
        source.appendChild(source_data)
        sourcedid.appendChild(source)
        id = self.user.createElement('id')
        id_data = self.user.createTextNode(str(sortsu_id))
        id.appendChild(id_data)
        sourcedid.appendChild(id)
	membership.appendChild(sourcedid)

	for juuser in kasutajad:
		member = self.user.createElement('member')
	        sourcedid = self.user.createElement('sourcedid')
	        source = self.user.createElement('source')
	        source_data = self.user.createTextNode('IVA')
	        source.appendChild(source_data)
	        sourcedid.appendChild(source)
	        id = self.user.createElement('id')
	        id_data = self.user.createTextNode(juuser.get_uname())
	        id.appendChild(id_data)
	        sourcedid.appendChild(id)
		member.appendChild(sourcedid)
	
		idtype = self.user.createElement('idtype')
		idtype_data = self.user.createTextNode('1')
		idtype.appendChild(idtype_data)
		member.appendChild(idtype)

		role = self.user.createElement('role')
		role.setAttribute('roletype','Learner')

                for abc in kogum.get_local_roles():
                        if abc[0]==juuser.get_uname() and 'Teacher' in abc[1]:
                                role.setAttribute('roletype','Instructor')

		status = self.user.createElement('status')
		status_data = self.user.createTextNode('1')
		status.appendChild(status_data)
		role.appendChild(status)
		if tyyp == 'kursus':
			self.kirjutaHinded(role,kogum,juuser)
		member.appendChild(role)
		membership.appendChild(member)
#	self.userelem.appendChild(membership)
	self.sisegrupid.append(membership)
	return

    def kirjutaHinded(self,base_elem,kogum,kasutaja):
	# kirjutab kasutaja hinded
	uname = kasutaja.get_uname()
	for abc in kogum.kodutood.listAssignments():
		punktid = -1
		komm = ""
		punktid = abc.getGrades(uname, 'points')
		komm = abc.getGrades(uname, 'comment')
		tkomm = abc.getGrades(uname, 'teacherComment')

		self.kirjutaInter(base_elem, abc, punktid, komm, tkomm)
	
	totPoints = kogum.kodutood.getOverallDetails(uname, 'TotPoints')
	allComment = kogum.kodutood.getOverallDetails(uname, 'overallComment')
	totPointsCom = kogum.kodutood.getOverallDetails(uname, 'TotPointsCom')
	grade = kogum.kodutood.getOverallDetails(uname, 'grade')
	gradeCom = kogum.kodutood.getOverallDetails(uname, 'gradeCom')
	
	self.kirjutaInter(base_elem, 'abc', 
		totPoints, allComment, totPointsCom, 
		grade, gradeCom, 
		mida='finalresult')
	return

    def kirjutaInter(self,base_elem, too, 
    		punktid, komm, tkomm, 
    		grade=-1, gradeCom=None, 
		mida='interimresult'
	):
	if punktid == -1:
		punktid = 0
	interim = self.user.createElement(mida)
	if mida == 'interimresult':
		interim.setAttribute('resulttype',too.id)
	
	mode = self.user.createElement('mode')
	if mida == 'interimresult':
		mode_data = self.user.createTextNode('Letter Grade')
	else:
		mode_data = self.user.createTextNode('protsent')
	mode.appendChild(mode_data)
	interim.appendChild(mode)

	values = self.user.createElement('values')
	values.setAttribute('valuetype','1')
	val_min = self.user.createElement('min')
	val_min_data = self.user.createTextNode('0')
	val_min.appendChild(val_min_data)
	values.appendChild(val_min)
	val_max = self.user.createElement('max')
	try:
		pp = str(too.getPoints())
	except:
		pp = '9999'
	val_max_data = self.user.createTextNode(pp)
	val_max.appendChild(val_max_data)
	values.appendChild(val_max)
	interim.appendChild(values)
	
	result = self.user.createElement('result')
	result_data = self.user.createTextNode(str(punktid))
	result.appendChild(result_data)
	interim.appendChild(result)
	
	comments = self.user.createElement('comments')
	comments_data = self.user.createTextNode(str(komm))
	comments.appendChild(comments_data)
	interim.appendChild(comments)

	tcomment = self.user.createElement('tcomment')
	tcomment_data = self.user.createTextNode(str(tkomm))
	tcomment.appendChild(tcomment_data)
	interim.appendChild(tcomment)

	if mida == 'finalresult':
		grade_node = self.user.createElement('grade')
		grade_data = self.user.createTextNode(str(grade))
		grade_node.appendChild(grade_data)
		interim.appendChild(grade_node)
		
		gradeCom_node = self.user.createElement('grade_com')
		gradeCom_data = self.user.createTextNode(str(gradeCom))
		gradeCom_node.appendChild(gradeCom_data)
		interim.appendChild(gradeCom_node)
	
	base_elem.appendChild(interim)    
	return

    def lisaMembership(self):
	for abc in self.sisegrupid:
		self.userelem.appendChild(abc)
	return


class Importer:
    def __init__(self, uname,ivajuur,prefix='', kursus='',binaryd='',testonly=0,userwikionly=0,kasuta_jooksvat=0):
	"""Creates impoter"""
        self.idmap = {}
	self.uname = uname
	self.prefix = prefix
	self.iva = ivajuur
	self.kasuta_jooksvat = kasuta_jooksvat
	if kursus:
		self.kursus = kursus
	else:
		self.kursus = ''
	if binaryd:
		self.binarydata = binaryd
	else:
	        self.binarydata = DataTable()
        self.timecounters=[0,0,0,0,0,0,0,0,0,0]
	self.processed = []
	self.testonly = testonly
	self.userwikionly = userwikionly

    def importTestAnswers(self,elem,tid,map):
	from YlTest import TestiVastused
	for r in elem.getElementsByTagName('response'):
		owner = self.get_attr(r,'owner')
		# get userobject. Vastuse omanik
		try:
			wt = getattr(self.iva.fle_users, owner).webtop
			wtc = getattr(wt, 'c'+self.kursus.get_id())
		except:
			continue
		if not hasattr(wtc.aq_self, 'testivastused'):
			wtc.manage_addProduct['OFSP'].manage_addFolder('testivastused')
			wtc.testivastused.id='testivastused'
		tv = getattr(wtc, 'testivastused')
		
		if not hasattr(tv, tid):
			tv.manage_addProduct['OFSP'].manage_addFolder(tid)
			tvx = getattr(tv, tid)
			tvx.id = tid
		else:
			tvx = getattr(tv,tid)
		
		#kiakse lbi erinevad testilahenduse variandid
		for ver in r.getElementsByTagName('version'):
			# lahendusvariandi id
			id = self.get_attr(ver,'id')
			if not hasattr(tvx.aq_self, id):
				t = TestiVastused()
				t.testinimi = id
				t.id = id
				tvx._setObject(id,t)
			verk = getattr(tvx, id)
			comment = self.get_attr(ver,'comment')	#anna kogu kommentaar
			try:
				verk.seaKoguKommentaar(comment)
			except AttributeError:
				#XXX:weird
				pass
			for yl in ver.getElementsByTagName('yl'):
				#testi lesande (objekti) id
				id = self.get_attr(yl,'id')
				comment = self.get_attr(yl,'comment')
				score = self.get_attr(yl,'score')
				tupe = self.get_attr(yl,'type')
				answer = self.get_text(yl)

				if answer == 'None': answer = None
				if tupe == 'List': answer = eval(answer)
				if not score: score = None
				if hasattr(verk,id):
					#XXX: I don't know if this is reasonable
					continue
				try:
					verk._setObject(id, map[id].koopia())
				except KeyError:
					continue
				ylobj = getattr(verk,id)
				ylobj.pakutudAndmed = answer
				ylobj.opetajaPunktid = score
				ylobj.seaOpetajaKommentaar(comment)

    def importQT(self, elem, course, uname):
	import YlTyybid
	from YlAlus import YlAlus
	from YlTyybid import ValikYlesanne, TekstivastusegaYlesanne, OigeTekstivastusegaYlesanne, MitmikvalikYlesanne, YksikvalikYlesanne, ArvuvahemikuliseVastusegaYlesanne, ProtsentYlesanne, VastavusYlesanne
	from YlTest import YlTest, LahendusLoad, LahendusLuba, TestiVastused
	id_map = {}
	comment =  self.get_text(elem.getElementsByTagName("qticomment")[0])
	t_tyybid = ('ValikYlesanne','MitmikvalikYlesanne','YksikvalikYlesanne','OigeTekstivastusegaYlesanne','TekstivastusegaYlesanne','ArvuvahemikuliseVastusegaYlesanne','VastavusYlesanne')
        for abc in elem.getElementsByTagName("section"):
		# get id and title
		sekt_title =  self.get_attr(abc,'title')
		id = self.get_attr(abc, 'ident')
		if not hasattr(course.testid,'nr'):
			course.testid.nr=0
		# add test. XXX: move this to top and start adding metadata
		course.testid.nr = course.testid.nr+1
		qt=YlTest()
		qt.pealkiri = sekt_title
#		qt.id = "test"+str(course.testid.nr)
#		course.testid._setObject(qt.id, qt)
		qt.id = id
		if hasattr(course.testid, qt.id):
			qt.id = "test"+str(course.testid.nr)
		
		# harvest data
		answers = self.get_attr(abc, 'answers')
		if not answers:
			answers=0
		qt.seaVastusteNahtavus(answers)
		open = self.get_attr(abc, 'open')
		if not open:
			open=0
		qt.avatudTaitmiseks = int(open)
		randomize = self.get_attr(abc, 'randomize')
		qt.seaKysimusteJuhuslikJarjekord(randomize)
		type = self.get_attr(abc, 'type')
		if not type:
			type=0
		qt.tyyp = int(type)
		try:
			md = abc.getElementsByTagName('metadata')[0]
			desc = self.get_text(md.getElementsByTagName('description')[0])
			qt.kirjeldus = desc

			# permission options!

			#timelimit and repeats
			tstart = float(self.get_attr(md.getElementsByTagName('timelimit')[0],'start'))
			tend = float(self.get_attr(md.getElementsByTagName('timelimit')[0],'end'))
			repeat = self.get_attr(md.getElementsByTagName('timelimit')[0],'repeat')
			qt.koigiLuba.algusAeg = tstart
			qt.koigiLuba.loppAeg = tend
			qt.koigiLuba.kordadeArv = int(repeat)
			from YlTest import LahendusLuba

			#groups
			for gr in md.getElementsByTagName('person'):
				try:
					name = self.get_attr(gr,'name')
				except:
					continue
				dm = LahendusLuba()
				#if name == 'DuMmY67891': continue
				tstart = float(self.get_attr(gr,'start'))
				tend = float(self.get_attr(gr,'end'))
				repeat = self.get_attr(gr,'repeat')
				dm.id = name
				dm.algusAeg = tstart
				dm.loppAeg = tend
				dm.kordadeArv = int(repeat)
				qt.isikuLoad._setObject(dm.id,dm)
		
			#persion
			for pr in md.getElementsByTagName('group'):
				try:
					name = self.get_attr(pr,'name')
				except:
					continue
				dm = LahendusLuba()
				#if name == 'DuMmY67891': continue
				tstart = float(self.get_attr(pr,'start'))
				tend = float(self.get_attr(pr,'end'))
				repeat = self.get_attr(pr,'repeat')
				dm.id = name
				dm.algusAeg = tstart
				dm.loppAeg = tend
				dm.kordadeArv = int(repeat)
				qt.grupiLoad._setObject(dm.id,dm)
			#limited solving time!?
			#finally, add object
		except IndexError:
			pass
		
		course.testid._setObject(qt.id, qt)
		test_map = {}
		
			
		for bcd in abc.getElementsByTagName("item"):
			try:
				qt_tyyp =  self.get_attr(bcd,'title')
			except IndexError:
				qt_tyyp = ''
			try:
				qt_id = self.get_attr(bcd,'ident')
			except IndexError:
				qt_id = ''
			try:
				qt_story = self.get_text(bcd.getElementsByTagName("qticomment")[0])
			except IndexError:
				qt_story = ''
			pelem = bcd.getElementsByTagName("presentation")[0]
			try:
				qt_quiz = self.get_text(pelem.getElementsByTagName("mattext")[0])
			except IndexError:
				qt_quiz = ''
			try:
				photo_data = self.binarydata.getData(
					self.get_attr(pelem.getElementsByTagName("matimage")[0],'uri'),self.prefix)
			except IndexError:
				photo_data = None 
			try:
				qt_link = self.get_text(pelem.getElementsByTagName("matemtext")[0])
				qt_linkd = self.get_attr(pelem.getElementsByTagName("matemtext")[0],'uri')
			except IndexError:
				qt_link = ''
				qt_linkd = ''

			try:
				r_grp =  pelem.getElementsByTagName("response_grp")[0]
				r_grp1 = 1
			except IndexError:
				r_grp1 = 0
			try:
				r_lid =  pelem.getElementsByTagName("response_lid")[0]
				r_lid1 = 1
			except IndexError:
				r_lid1 = 0
			try:
				r_xy = pelem.getElementsByTagName("response_xy")[0]
				r_xy1 = 1
			except IndexError:
				r_xy1 = 0
			try:
				r_str = pelem.getElementsByTagName("response_str")[0]
				r_str1 = 1
			except IndexError:
				r_str1 = 0
			try:
				r_num = pelem.getElementsByTagName("response_num")[0]
				r_num1 = 1 
			except IndexError:
				r_num1 = 0
			if r_lid1:
				try:
					r_render = pelem.getElementsByTagName("render_choice")[0]
					rend = 1
				except:
					rend = 0
				if rend and qt_tyyp not in t_tyybid:
					qt_tyyp = 'MitmikvalikYlesanne'
			if r_str1:
				r_fib1 = 0
				try:
					r_fib = pelem.getElementsByTagName("render_fib")[0]
					r_fib1 = 1
				except:
					r_fib1 = 0
				if r_fib1:
					if qt_tyyp not in t_tyybid:
						try:
							xx = bcd.getElementsByTagName("varequal")[0]
							tmp = 1
						except:
							tmp = 0
						if tmp:
							qt_tyyp = 'OigeTekstivastusegaYlesanne'
						else:
							qt_tyyp = 'TekstivastusegaYlesanne'

			if qt_tyyp == 'ValikYlesanne':
				vastus = self.get_text(bcd.getElementsByTagName("varequal")[0])
				if vastus == 'T': 
					vastus =1 
				else: 
					vastus =0
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = ValikYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
				qt_test.seaKirjeldavTekst('',qt_story)
				qt_test.normPunktid=float(punkte)
				qt_test.viiteURL = qt_linkd
				qt_test.viiteTekst = qt_link
				qt_test.vastus = vastus
				qt_test.pilt =  photo_data
				# pistame testi hoidlasse
				pass
			if qt_tyyp == 'MitmikvalikYlesanne':
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = MitmikvalikYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				oiged = []
                                v_text = []
                                v_id = []
                                s_text = []
                                s_id = []

				for xbc in bcd.getElementsByTagName("varequal"):
					oiged.append(self.get_text(xbc))
				for vastused in bcd.getElementsByTagName("response_label"):
					v_id.append(self.get_attr(vastused,'ident'))
					v_text.append(self.get_text(vastused.getElementsByTagName("mattext")[0]))
				for seletused in bcd.getElementsByTagName("itemfeedback"):
					s_id.append(self.get_attr(seletused, 'ident'))
					s_text.append(self.get_text(seletused.getElementsByTagName("mattext")[0]))
				
                                v_sisse = []
                                s_sisse = []
				o_sisse = []
                                j = 0

				for vmass in v_id:
					i = 0
					for smass in s_id:
						if vmass == smass:
							v_sisse.append(v_text[j])
							s_sisse.append(s_text[i])
						i = i + 1
					try:
						if str(vmass) in oiged:
							o_sisse.append(int(j))
					except:
						pass
					j = j + 1
				
				qt_test.valikud = v_sisse
				qt_test.selgitused = s_sisse
				qt_test.oigedValikud = o_sisse
				pass
			if qt_tyyp == 'YksikvalikYlesanne':
				vastus = self.get_text(bcd.getElementsByTagName("varequal")[0])
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = YksikvalikYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				v_text = []
				v_id = []
				s_text = []
				s_id = []
				for vastused in pelem.getElementsByTagName("response_label"):
					v_id.append(self.get_attr(vastused,'ident'))
					v_text.append(self.get_text(vastused.getElementsByTagName("mattext")[0]))
				for seletused in bcd.getElementsByTagName("itemfeedback"):
					s_id.append(self.get_attr(seletused, 'ident'))
					s_text.append(self.get_text(seletused.getElementsByTagName("mattext")[0]))
				v_sisse = []
				s_sisse = []
                                s_id.reverse()
                                s_text.reverse()
				j = 0
				for vmass in v_id:
					i = 0
					for smass in s_id:
						if vmass == smass:
							v_sisse.append(v_text[j])
							s_sisse.append(s_text[i])
						i = i + 1
					if vmass == str(vastus):
						qt_test.oigeValik = j
					j = j + 1
				qt_test.valikud = v_sisse
				qt_test.selgitused = s_sisse
				pass
			if qt_tyyp == 'OigeTekstivastusegaYlesanne':
				try:
					punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				except:
					punkte = 0
				qt_test = OigeTekstivastusegaYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				oiged = []
                                for xbc in bcd.getElementsByTagName("varequal"):
                                        oiged.append(self.get_text(xbc))
				qt_test.variandid = oiged
				pass
			if qt_tyyp == 'TekstivastusegaYlesanne':
				try:
	                                punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				except:
					punkte = 0
                                qt_test = TekstivastusegaYlesanne(qt_quiz)
                                yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data
				pass
			if qt_tyyp == 'ArvuvahemikuliseVastusegaYlesanne':
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = ArvuvahemikuliseVastusegaYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data
				arv_tyyp = bcd.getElementsByTagName("outcomes")[0]
				q_arv_tyyp = self.get_text(arv_tyyp.getElementsByTagName("qticomment")[0])
				q_alam = self.get_text(bcd.getElementsByTagName("vargte")[0])
				q_oige = self.get_text(bcd.getElementsByTagName("varequal")[0])
				q_ylem = self.get_text(bcd.getElementsByTagName("varlte")[0])
				qt_test.alamPiir = float(q_alam)
				qt_test.ylemPiir = float(q_ylem)
				qt_test.oigeVastus = float(q_oige)
				try:
					qt_test.arvutusTyyp = int(q_arv_tyyp)
				except:
					pass
				pass
			if qt_tyyp == 'VastavusYlesanne':
				import random
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = VastavusYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				v_id = []
				v_text = []
				for xbc in bcd.getElementsByTagName("response_label"):
					v_id.append(self.get_attr(xbc,'ident'))
					v_text.append(self.get_text(xbc.getElementsByTagName("mattext")[0]))
				s_vastused = []
				s_kysimused = []
				for xbc in bcd.getElementsByTagName("varsubset"):
					paar = string.split(self.get_text(xbc),",")
					koht_v = v_id.index(paar[0])
					koht_p = v_id.index(paar[1])
					s_kysimused.append(v_text[koht_v])
					s_vastused.append(v_text[koht_p])
				s_jarjestus = []
				for i in range(len(s_kysimused)):
					s_jarjestus.append(i)
				random.shuffle(s_jarjestus)
				qt_test.kysimused = s_kysimused
				qt_test.vastused = s_vastused
				qt_test.jarjestus = s_jarjestus
				pass
			try:
				test_map[qt_id] = qt_test
			except UnboundLocalError:
				#XXX:some test is missing!
				pass
		self.importTestAnswers(abc,id,test_map)
	return

    def importCourseCats(self, element):
	""" import course categories """
	cats = element.getElementsByTagName('categories')[0]
	cats_text = self.get_text(cats)
	cats_eval = eval(cats_text)
	cm = self.iva.courses
	cm.cCategories = cats_eval
	cm._p_changed = True
	return 1

    def importMailMessages(self,element):
	# import inner-mail messages
	um = self.iva.fle_users
	for cat in element.getElementsByTagName('catalog'):
		owner = self.get_attr(cat,'owner')
		try:
			ui = getattr(um, owner)
		except:
#			print "kasutajat %s ei leitnud, jtan vahele" % owner
			continue
		box = ui.kysiKirjadeKataloog()
		for mess in cat.getElementsByTagName('message'):
			read = int(self.get_attr(mess,'read'))
			owncopy = self.get_attr(mess,'owncopy')
			title = self.get_text(mess.getElementsByTagName('title')[0])
			body = self.get_text(mess.getElementsByTagName('body')[0])
			sender = self.get_text(mess.getElementsByTagName('sender')[0])
			receiver = self.get_text(mess.getElementsByTagName('receiver')[0])
			date = self.get_text(mess.getElementsByTagName('date')[0])
			mail = box.lisaKiri(None,title,body,sender,receiver,99999)
			mail.loomisaeg = float(date)
			if owncopy: mail.omakopi = 1
			if read:
				mail.loetud = 1
			else:
				mail.loetud = 0


    def importKodutood(self,element):
	# impordime kodutd
	kt_koht = getattr(self.kursus,'kodutood')
	grupid = []
	for assign in element.getElementsByTagName('Assignment'):
		try:
			orgID = self.get_attr(assign,'originalID')
		except:
			orgID = ''
		tyyp = int(self.get_text(assign.getElementsByTagName('type')[0]))
		pkiri = str(self.get_text(assign.getElementsByTagName('title')[0]))
		kirjeldus = str(self.get_text(assign.getElementsByTagName('description')[0]))
		punkt = float(self.get_text(assign.getElementsByTagName('points')[0]))
		try:
			res = str(self.get_text(assign.getElementsByTagName('resource')[0]))
		except:
			res = ''
		loppaeg = self.get_text(assign.getElementsByTagName('end')[0])
		try:
			testiID = str(self.get_text(assign.getElementsByTagName('test')[0]))
		except:
			testiID = None
		try:
			for gr in assign.getElementsByTagName('group'):
				gnimi = self.get_text(gr)
				grupid.append(gnimi)
		except:
			grupid = None
		if res:
			sisu = res.split('/')
			res = '/courses/'+str(self.kursus.id)+"/"+sisu[3]+"/"+sisu[4]
		too = kt_koht.lisaKodutoo('request',tyyp,orgID)
		too.pealkiri = pkiri
		too.kirjeldus = kirjeldus
		too.normPunkte = punkt
		too.juhend = res
		if loppaeg != 'None':
			too.loppaeg = float(loppaeg)
		# New parameter
		too.lockingFolder = 0
		if testiID != None:
			too.testiID = testiID
		if grupid != None:
			too.grupid = grupid
	return

    def handleGrades(self,isik,uid):
	for x in isik.getElementsByTagName('interimresult'):
		workid = self.get_attr(x, 'resulttype')
		try:
			points = float(self.get_text(x.getElementsByTagName('result')[0]))
		except:
			points = ''
		try:
			s_com = self.get_text(x.getElementsByTagName('comments')[0])
		except:
			s_com = ''
		try:
			t_com = self.get_text(x.getElementsByTagName('tcomment')[0])
		except:
			t_com = ''
		if points:
			self.kursus.kodutood.setUserPoints(workid,uid,'points',points)
		self.kursus.kodutood.setUserPoints(workid,uid,'comment',s_com)
		self.kursus.kodutood.setUserPoints(workid,uid,'teacherComment',t_com)
	f = isik.getElementsByTagName('finalresult')[0]
	try:
		grade = self.get_text(f.getElementsByTagName('result')[0])
		if grade:
			self.kursus.kodutood.setUserOverall(uid,'grade',grade)
	except:
		pass
	try:
		comment = self.get_text(f.getElementsByTagName('comments')[0])	#overall comment
		self.kursus.kodutood.setUserOverall(uid,'overallComment',comment)
	except:
		pass
	try:
		t_com = self.get_text(f.getElementsByTagName('tcomment')[0])
		self.kursus.kodutood.setUserOverall(uid,'gradeCom',t_com)
	except:
		pass
	try:
		modpoints = float(self.get_text(f.getElementsByTagName('modpoints')[0]))
		if modpoints:
			self.kursus.kodutood.setUserOverall(uid,'TotPoints',modpoints)
	except:
		pass
	try:
		modcomment = self.get_text(f.getElementsByTagName('modcomment')[0])
		self.kursus.kodutood.setUserOverall(uid,'TotPointsCom',modcomment)
	except:
		pass
	

    def lisaIsik(self,isik,tyyp,grupinimi=''):
	uid = self.get_text(isik.getElementsByTagName('id')[0])
	print uid
	roll = self.get_attr(isik.getElementsByTagName('role')[0],'roletype')
	if tyyp == 'kursus':
		try:
			self.kursus.add_student(uid)
			#handle grades here! interimresult, finalresult
			self.handleGrades(isik,uid)
			if roll == 'Instructor':
				self.kursus.set_roles(uid,('Teacher',))
			#else:
				#XXX:we already set Student in add_student
				#self.kursus.set_roles(uid,('Student',))
		except:
			pass
	else:
		self.kursus.lisa_sisegruppi(grupinimi,uid)
	return

    def restoreMembership(self,failisisu):
	sisegr = self.kursus.subgroups.objectValues()
	sisegrupid = []
	for grupid in sisegr:
		sisegrupid.append(grupid.get_name())
	for group in failisisu.getElementsByTagName('group'):
		id = self.get_text(group.getElementsByTagName('id')[0])
		try:
			typevalue = self.get_attr(group.getElementsByTagName('typevalue')[0],'level')
		except:
			typevalue = ''
		if str(typevalue) == '1':
			try:
				orgname = self.get_text(group.getElementsByTagName('orgname')[0])
			except:
				orgname = 'orgnameorgnameorgname'
	#		if self.kursus:
	#			if str(orgname) == str(self.kursus.get_name()):
	#				pass
    			for ship in failisisu.getElementsByTagName('membership'):
				try:
					komm = self.get_text(ship.getElementsByTagName('comments')[0])
				except:
					komm = ''
				ship_id = self.get_text(ship.getElementsByTagName('id')[0])
#				k_nimi = self.kursus.get_name()+' *'
#				if ship_id+' *' == str(self.kursus.get_name()) == id+' *' and str(komm) == 'KURSUS':
				if ship_id == str(self.kursus.get_name()) == id and str(komm) == 'KURSUS':
					for isik in ship.getElementsByTagName('member'):
						self.lisaIsik(isik,'kursus')
		else:
			id = self.get_text(group.getElementsByTagName('id')[0])
			if not id in sisegrupid:
				try:
					sgr = self.kursus.lisa_grupp(id)
					sgr.kysiSyndmusteKataloog()
				except:
					pass
			for ship in failisisu.getElementsByTagName('membership'):
				try:
					komm = self.get_text(ship.getElementsByTagName('comments')[0])
				except:
					komm = ''
				if str(komm) == 'SISEGRUPP':
					ship_id = self.get_text(ship.getElementsByTagName('id')[0])
					if ship_id == id:
						for isik in ship.getElementsByTagName('member'):
							self.lisaIsik(isik,'sisegrupp',id)
	return

    def importUsers(self,element):
	um = getattr(self.iva, 'fle_users')
	tulem = ""
	us_alg = time.time()
	for person in element.getElementsByTagName('person'):
		roles = []
		userid =  self.get_text(person.getElementsByTagName('userid')[0])
#		if userid=='admin':
#			continue
		password = self.get_attr(person.getElementsByTagName('userid')[0],'password')
		try:
			family = self.get_text(person.getElementsByTagName('family')[0])
		except:
			family = ''
		try:
			given = self.get_text(person.getElementsByTagName('given')[0])
		except:
			given = ''
		try:
			email = self.get_text(person.getElementsByTagName('email')[0])
		except:
			email = ''
		try:
			url = self.get_text(person.getElementsByTagName('url')[0])
		except:
			url = ''
		try:
			for telephones in person.getElementsByTagName('tel'):
				if self.get_attr(telephones,'teltype') == 'Voice':
					voice = self.get_text(telephones)
				else:
					mobile = self.get_text(telephones)
		except:
			voice = ''
			mobile = ''
		try:
			addr2 = self.get_text(person.getElementsByTagName('extadd')[0])
		except:
			addr2 = ''
		try:
			street = self.get_text(person.getElementsByTagName('street')[0])
		except:
			street = ''
		try:
			locality = self.get_text(person.getElementsByTagName('locality')[0])
		except:
			locality = ''
		try:
			country = self.get_text(person.getElementsByTagName('country')[0])
		except:
			country = ''
		try:
			photo_tag = person.getElementsByTagName('photo')[0]
			photo_type = self.get_attr(photo_tag,'imgtype')
			photo_location = self.get_text(photo_tag.getElementsByTagName('extref')[0])
			photo = self.binarydata.getData(photo_location, self.prefix)
		except:
			photo = None
		try:
			s_r = person.getElementsByTagName('systemrole')[0]
			systemrole = self.get_attr(s_r,'systemroletype')
			if systemrole == 'SysAdmin':
				roles.append('Manager')
		except:
			systemrole = ''
		try:
			i_r = self.get_text(person.getElementsByTagName('institutionrole')[0])
			inst_role = self.get_attr(i_r,'institutionroletype')
		except:
			instrole = ''
		try:
			eriala = self.get_text(person.getElementsByTagName('orgname')[0])
		except:
			eriala = ''
		try:
			comm = self.get_text(person.getElementsByTagName('comments')[0])
		except:
			comm = ''
		try:
			huvid = self.get_text(person.getElementsByTagName('short')[0])
		except:
			huvid = ''
		try:
			amet_huvid = self.get_text(person.getElementsByTagName('long')[0])
		except:
			amet_huvid = ''
		try:
			label = self.get_text(person.getElementsByTagName('label')[0])
		except:
			label = ''
		try:
			if um.kasKasutajaOlemas(userid) and hasattr(um, userid):
				tulem = "kasutaja "+userid+" olemas"
				continue
		except AttributeError:
			pass
			#XXX: we need to do something clever here since acl_users folder does not support some function. 
		if not um.kasKasutajaOlemas(userid):
			um.acl_users._doAddUser(userid,password,[],())
		if not hasattr(um, userid):
			kasutaja = um.add_user_fle(userid,('Member',))
		else:
			kasutaja = getattr(um.aq_self, userid)
		kasutaja.kysiSyndmusteKataloog()
		kasutaja.edit_info(given,family,email,eriala,'keel',photo,'','',street,addr2,
			locality,country,url,voice,mobile,label,comm,huvid,amet_huvid)
		if photo != None:
			kasutaja.set_photo(photo,photo_type)
	us_lopp = time.time()
	print "Users:",us_lopp-us_alg
	return

    def test(self,elem, folder, uname, indeks,loop=0):
	for bcd in elem.childNodes:
		if bcd.nodeType == 1 and bcd.nodeName == 'resource':
			pid = self.get_attr(bcd,"identifier")
			if indeks[self.eemalda(pid)] == self.eemalda(folder.id):
				tyyp = self.get_attr(bcd,'type')
				name = self.get_text(bcd.getElementsByTagName("title")[0])
				if tyyp == 'file':
					data_name = self.get_attr(bcd.getElementsByTagName("file")[0],'href')
					data = self.binarydata.getData(data_name,self.prefix)
					file = folder.add_file(name, 
						FakeUpload(name,data,'application/msword'))
				if tyyp == 'memo':
					sisu = self.get_text(bcd.getElementsByTagName("description")[0])
					memo = folder.add_memo(name,sisu)
				if tyyp == 'URL':
					sisu = self.get_attr(bcd,'href')
					link = folder.add_link(name, sisu)
	if loop==0:
		folder = getattr(folder,folder.id)
		self.importItems(elem,folder,uname,indeks)
	return folder

    def importItems(self, elem, course, uname, indeks,loop=0):
	if loop:
		self.test(elem,course,uname,indeks,loop=1)
	for abc in course.objectValues():
		if abc.meta_type == 'WebtopFolder': 
			folder = getattr(course,abc.id)
			self.test(elem,folder,uname, indeks)
	return "kala"

    def get_text(self,elem):
	res=u''
	for line in elem.childNodes:
        	res += line.nodeValue
	return to_utf8(res)
    def get_attr(self,elem,name):
	return to_utf8(elem.getAttribute(name))

    def eemalda(self,pid):
	try:
		number = int(re.sub('[a-zA-Z]','',pid))
	except ValueError:
		number = 0
	return number 

    def importOrg(self,elem,course):
	for abc in elem.getElementsByTagName("organization"):
		if self.get_text(abc.getElementsByTagName("title")[0]) == "Raamaturiiul":
			nelem = abc
	abc = nelem.getElementsByTagName("item")[0]
	return abc

    def createCourse(self,elem,courses,teacher):
	""" creates an empty course, other functions fill this with data
	    course will be named imported_+exported course name """
	vigu = 0
	try:
		title = elem.getElementsByTagName("imsmd:title")[0]
        	title_c = self.get_text(title.getElementsByTagName("imsmd:langstring")[0])
	except:
		vigu = vigu +1

	try:
		c_organisation = self.get_text(elem.getElementsByTagName("ivamd:organisation")[0])
	except:
		c_organisation = ""
		vigu = vigu+1
	try:
		c_method = self.get_text(elem.getElementsByTagName("ivamd:methods")[0])
	except:
		c_method = ""
		vigu = vigu+1
	try:
		c_quote = self.get_text(elem.getElementsByTagName("ivamd:quote")[0])
	except:
		c_quote = ""
		vigu = vigu+1
	try:
		c_status = int(self.get_text(elem.getElementsByTagName("ivamd:status")[0]))
	except:
		c_status = 0
		vigu = vigu+1
	try:
		c_picture_name = self.get_attr(elem.getElementsByTagName("ivamd:picture")[0],"href")
		c_picture = self.binarydata.getData(c_picture_name,self.prefix)
	except:
		c_picture = None
		vigu = vigu+1
	try:
		desk = elem.getElementsByTagName("imsmd:description")[0]
		desk_c = self.get_text(desk.getElementsByTagName("imsmd:langstring")[0])
#		title_c = "imported_"+title_c
	except:
		desk = ''
		vigu = vigu+1
	if vigu < 3:
			# don't change the below line in haste
#			title_c += " *"
			id = courses.add_course_impl(teacher)
			course = courses.get_child(str(id))
			course.remove_person(teacher)
			course.update(title_c,desk_c,c_organisation,c_method,0,0,c_quote,c_picture,c_status)
			#course.kontrolliRyhmaLaud()
			course.add_folder('CourseFolder')
			course.kysiSyndmusteKataloog()
			return course 
	else:
		pass
		#print "vigu:", vigu
		#print "vigu tekkis liialt palju, jtan kursuse tegemise katki"
	return 0

    def lisaSyndmus(self,resource,tiitel):
	from Kalender import KalendriSyndmus, KalendriSyndmusteKataloog 
	import time
	for fail in resource.getElementsByTagName('file'):
		href = self.get_attr(fail,'href')
		syndmused = self.binarydata.getData(str(self.prefix+href))
		synd = syndmused.split('\r\n')
		synd_p = []
		for abc in synd:
		    try:
			if abc[0] == ' ':
				eelmine = synd_p.pop()
				synd_p.append(eelmine + " "+abc)
			else:
				synd_p.append(abc)
		    except:
			pass
		final = []
		for abc in synd_p:
			uu = abc.split(':',1)
			final.append(uu)
		v_cal = 0
		v_event = 0
		v_loend = 0
		for syndmus in final:
			if syndmus[0] == 'BEGIN' and syndmus[1] == 'VCALENDAR':
				v_cal = 1
			if not v_cal:
				continue
			if syndmus[0] == 'BEGIN' and syndmus[1] == 'VEVENT':
				v_event = 1
			if not v_event:			# no point to collect data
				continue		# if we don't have event

			if syndmus[0] == 'DTSTART' or syndmus[0] == 'DTEND':
				temp = syndmus[1]
                                aeg = []
                                aeg.append(int(temp[0:4]))
                                aeg.append(int(temp[4:6]))
                                aeg.append(int(temp[6:8]))
                                aeg.append(int(temp[9:11]))
                                aeg.append(int(temp[11:13]))
                                aeg.append(int(temp[13:15]))
                                aeg.append(int(0))
                                aeg.append(int(0))
                                aeg.append(int(0))
			if syndmus[0] == 'DTSTART':
				v_loend = v_loend +1
				dtstart = time.mktime(aeg)
			if syndmus[0] == 'DTEND':
				v_loend = v_loend +1
				dtend = time.mktime(aeg) 
			if syndmus[0] == 'N':
				v_loend = v_loend +1
				n = syndmus[1]
			if syndmus[0] == 'DESCRIPTION':
				v_loend = v_loend +1
				desc = syndmus[1]
			if syndmus[0] == 'SUMMARY':
				v_loend = v_loend +1
				summary = syndmus[1]
			if syndmus[0] == 'STATUS':
				v_loend = v_loend +1
				status = int(syndmus[1])
			if syndmus[0] == 'CUTYPE':
				v_loend = v_loend +1
				cutype = syndmus[1]
			if syndmus[0] == 'URL':
				v_loend = v_loend +1
				url = syndmus[1]
			if syndmus[0] == 'X-PROPERTY;VALUE=NAME':
				v_loend = v_loend +1
				name = syndmus[1]
			if syndmus[0] == 'RESOURCES':
				v_loend = v_loend +1
				res = syndmus[1]

                        if syndmus[0] == 'END' and syndmus[1] == 'VCALENDAR':
				break
                        if not v_cal:
                                continue
                        if syndmus[0] == 'END' and syndmus[1] == 'VEVENT':
				if v_loend > 5:
					# try make an event
					koht = None
					if cutype == 'INDIVIDUAL':
						try:
							temp = getattr(self.iva.fle_users, n)
							koht = getattr(temp, 'syndmused')
						except:
							pass
					if cutype == 'GROUP':
						try:
							temp = getattr(self.iva.courses, str(self.kursus.get_id()))
						except AttributeError:
							print "XXXX: we couldn't find a course we should have made!"
							continue
						if n == 'kursus':
#							koht = getattr(temp, 'syndmused')
							koht = temp.kysiSyndmusteKataloog()
						else:
							try:
								temp2 = getattr(temp.subgroups, n)
								koht = temp2.kysiSyndmusteKataloog()
							except:
								loodud = self.kursus.lisa_grupp(n)
								koht = loodud.kysiSyndmusteKataloog()
					if not koht:
						break	# no place to event
					syndmus = koht.lisaSyndmusKohe(name, summary, desc, dtstart, dtend, url, res, status)
					self.set_omanik(syndmus, self.owner)
                                v_event = 0
				v_loend = 0
                        if not v_event:
                                continue
				
	return

    def ImportUserEvents(self,resource,tiitel):
	for org in resource.getElementsByTagName('organization'):
		id = self.get_attr(org,'identifier')		
		temp = id.split('_')
		juuser = temp[1]
		self.owner = juuser
		for item in org.getElementsByTagName('item'):
			idref = self.get_attr(item,'identifierref')
			tiitel = self.get_text(item.getElementsByTagName('title')[0])
			self.otsiTarget(idref,resource,tiitel)
	self.owner = self.uname
	return

    def add_file_metadata(self,object,element):
	""" file metadata extraction and handling here only """
	try:
		md = element.getElementsByTagName('metadata')[0]
		creationtime = float(self.get_attr(md,'creationtime'))
		object.set_timestamp(creationtime)
	except:
		pass
	for an in element.getElementsByTagName('annotation'):
		type = self.get_attr(an, 'parameters')
		if type != 'comment':
			continue
		person = self.get_text(an.getElementsByTagName('person')[0])
		date = float(self.get_text(an.getElementsByTagName('date')[0]))
		desc = self.get_text(an.getElementsByTagName('description')[0])
		status = int(self.get_text(an.getElementsByTagName('status')[0]))
		value = self.get_text(an.getElementsByTagName('value')[0])
		object.postComment(None,'add',desc,value,status,person,date)
	try:
		p = element.getElementsByTagName('permission')[0]
	except:
		return
	status = int(self.get_text(p.getElementsByTagName('status')[0]))	#permission status actually
	object.setObjPermission(status)
	position = int(self.get_text(p.getElementsByTagName('position')[0]))
	object.weight = position
	tl = p.getElementsByTagName('timelimits')[0]
	tend = float(self.get_attr(tl, 'end'))
	tstart = float(self.get_attr(tl, 'start'))
	object.setTimeLimits(tstart,tend)
	tfunc = int(self.get_text(tl))
	object.setTimeFunc(tfunc)
	
	docstatus = int(self.get_text(p.getElementsByTagName('docstatus')[0]))
	object.setStatus(docstatus)
	commentable = int(self.get_text(p.getElementsByTagName('commentable')[0]))
	object.setCommentable(commentable)
	comment_view = int(self.get_attr(p.getElementsByTagName('commentable')[0],'view'))
	object.setCommentsVisible(comment_view)
	rateable = int(self.get_text(p.getElementsByTagName('rateable')[0]))
	object.setRateable(rateable)
	rate_view = int(self.get_attr(p.getElementsByTagName('rateable')[0],'view'))
	object.setRatingVisible(rate_view)
	return
	

    def add_folder_metadata(self,object,element):
	""" folder metadata extraction here ONLY! """
	try:
		pres = self.get_attr(element,'presentation')
		if pres == '1':
			object.seaEsitluskaust(int(pres))
	except AttributeError:
		pass
	try:
		md = element.getElementsByTagName('metadata')[0]
		#XXX: We don't have any metadata. Happened when exported just a wiki
	except IndexError:
		return
	try:
		creationtime = float(self.get_attr(md,'creationtime'))
		object.set_timestamp(creationtime)
	except:
		pass
	for an in element.getElementsByTagName('annotation'):
		type = self.get_attr(an, 'parameters')
		if type != 'visit':
			continue
		person = self.get_text(an.getElementsByTagName('person')[0])
		date = float(self.get_text(an.getElementsByTagName('date')[0]))
		object.kylastus(None,person,date)
	try:
		p = element.getElementsByTagName('permission')[0]
	except:
		return
	status = int(self.get_text(p.getElementsByTagName('status')[0]))	#permission status actually
	object.setObjPermission(status)
	position = int(self.get_text(p.getElementsByTagName('position')[0]))
	object.weight = position
	tl = p.getElementsByTagName('timelimits')[0]
	tend = float(self.get_attr(tl, 'end'))
	tstart = float(self.get_attr(tl, 'start'))
	object.setTimeLimits(tstart,tend)
	tfunc = int(self.get_text(tl))
	object.setTimeFunc(tfunc)
	return 

    def handleMetadata(self,element):
	try:
		format = self.get_text(element.getElementsByTagName('imsmd:format')[0])
	except:
		format = 'application/msword'
	return format 


    def set_omanik(self,obj,omanik):
	try:
		obj.manage_setLocalRoles(omanik, ('Owner',))
		acl = self.iva.fle_users.leiaKasutajaKataloog(omanik)
		acl_user = acl.aq_inner.getUser(omanik)
		obj.changeOwnership(self.iva.acl_users.getUser(omanik).__of__(self.iva.acl_users))
	except:
		return 0
	return 1

    def handleResource(self,resource,asukoht,resour,tiitel=''):
	tyyp = self.get_attr(resource,'type')
	for element in resource.childNodes:
		# otsi ja leia failid, memod jms
		if element.nodeName == 'dependency':
			idref = self.get_attr(element, 'identifierref')
			self.otsiTarget(idref,resour,'MISC STUFF',asukoht)
		if element.nodeName != 'file':
			#vib vajada fixi.
			continue
		else:
			tekst = ''
			orgID = ''
			try:
				href = self.get_attr(element,'href')
			except:
				pass
			try:
				tekst = self.get_text(element.getElementsByTagName('imsmd:title')[0])
			except:
				pass
			try:
				if not tekst:
					tekst = self.get_text(element.getElementsByTagName('title')[0])
			except:
				pass
			try:
				orgID = self.get_attr(element.getElementsByTagName('imsmd:title')[0],'originalID')
			except:
				pass
			try:
				orgID = self.get_attr(element.getElementsByTagName('title')[0],'originalID')
			except:
				pass
			try:
				orgOwner = self.get_attr(element.getElementsByTagName('imsmd:title')[0],'originalOwner')
			except:
				pass
			try:
				orgOwner = self.get_attr(element.getElementsByTagName('title')[0],'originalOwner')
			except:
				pass
			if tyyp == 'file' or tyyp == 'webcontent':
				fail_alg = time.time()
				# FIXFIXFIX: faili formatt
				try:
					format = self.handleMetadata(element.getElementsByTagName('metadata')[0])
				except:
					format = 'application/msword'
				href = self.get_attr(element,'href')
				data_alg = time.time()
				data = self.binarydata.getData(str(self.prefix+href))
				data_lopp = time.time()
				print "Faili lugemine",data_lopp-data_alg
				# FIX: file type
				number = 1
				if not tekst:
					tekst = tiitel
					number = 0
				lisa_alg = time.time()
				try:
					fail = asukoht.add_file(tekst,FakeUpload(tekst,data,format),number)
				except:
					fail = asukoht.add_file(tekst,FakeUpload(tekst,data,format),0)
				lisa_lopp = time.time()
				print "lisa fail:",lisa_lopp-lisa_alg
				result = self.set_omanik(fail,orgOwner)
				if not result:
					self.set_omanik(fail,self.owner)
				self.add_file_metadata(fail,element)
				fail_lopp = time.time()
				print "Fail:",fail_lopp-fail_alg
			if tyyp == 'memo':
				data = self.binarydata.getData(str(self.prefix+href))
				memo = asukoht.add_memo(tekst,data)
		#		memo.set_author(self.owner)
				memo.manage_delLocalRoles((self.uname,))
				result = self.set_omanik(memo,orgOwner)
				if not result:
					self.set_omanik(memo,self.owner)
				self.add_file_metadata(memo,element)
			if tyyp == 'URL':
				link = asukoht.add_link(tekst,href)
			#	link.set_author(self.owner)
				link.manage_delLocalRoles((self.uname,))
				result = self.set_omanik(link,orgOwner)
				if not result:
					self.set_omanik(link,self.owner)
				self.add_file_metadata(link,element)
				#XXX:wikipages and owners
			if tyyp == 'wikipage':
				if hasattr(asukoht.aq_inner.aq_self, tiitel):
#					wikipage = getattr(asukoht, tiitel)
					asukoht._delObject(tiitel)
				data = self.binarydata.getData(str(self.prefix+href))
#				wikipage = ZWikiPage(source_string=data, __name__=tiitel)
				wikipage = ZWikiPage(source_string=data, __name__=tiitel)
				parent = [self.wikiparent]
				wikipage.parents = parent
				#XXX: we d'nt catalog wikis. 
#				wikipage.index_object()
				asukoht._setObject(tiitel,wikipage)
#				wikipage += 'lammas tuli klla!!'
			if tyyp == 'wikiimage' or tyyp == 'wikifile':
				if hasattr(asukoht.aq_inner.aq_self, tiitel):
					asukoht._delObject(tiitel)
				data = self.binarydata.getData(str(self.prefix+href))
				if tyyp == 'wikiimage':
					asukoht._setObject(tiitel, OFS.Image.Image(tiitel,tiitel,''))
				else:
					asukoht._setObject(tiitel, OFS.Image.File(tiitel,tiitel,''))
				asukoht._getOb(tiitel).manage_upload(data)
	return

    def createFolder(self,asukoht,nimi,orgID='',orgOwner=''):
	#XXX: we should try to handle real object id here somehow!
	# loo kaust
#	try:
#	print asukoht.absolute_url()
#	print nimi
	if 1==1:
		kaust = asukoht.add_folder(nimi,orgID)
		if orgOwner:
			self.set_omanik(kaust, orgOwner)
		else:
			self.set_omanik(kaust, self.owner)
#	except:
	return kaust

    def otsiItemid(self,item,tiitel,asukoht,resour,start=0):
	# resources tagi ka siia tooma
	try:
		params = self.get_attr(item,'parameters')
	except:
		params = ''
	tit = self.get_text(item.getElementsByTagName('title')[0])
	try:
		orgID = self.get_attr(item.getElementsByTagName('title')[0],'originalID')
	except:
		orgID = ''
	try:
		orgOwner = self.get_attr(item.getElementsByTagName('title')[0],'originalOwner')
	except:
		orgOwner = ''
	if not start:
		if not self.testonly:
			uusfolder = self.createFolder(asukoht,tit,orgID,orgOwner)
			self.add_folder_metadata(uusfolder,item)
#			asukoht = getattr(asukoht,tit)
	idref = self.get_attr(item,'identifierref')
	try:
		self.otsiTarget(idref,resour,'MISC STUFF',getattr(asukoht,uusfolder.id),params)
	except:
		self.otsiTarget(idref,resour,'MISC STUFF',asukoht,params)
        for bcd in item.childNodes:
                if bcd.nodeType == 1 and bcd.nodeName == 'item':
			#otsi itemi tiitel
			#otsi identifierref
			try:
				temp = getattr(asukoht,uusfolder.id)
			except:
				temp = asukoht
			self.otsiItemid(bcd,tiitel,temp,resour)
	return

    def otsiWikid(self,item,tiitel,asukoht,resour,start=0,vanem=''):
	tit = self.get_text(item.getElementsByTagName('title')[0])
	self.wikiparent = ''
	idref = self.get_attr(item,'identifierref')
	start = 0
	if not start:
		self.wikiparent = vanem
		self.otsiTarget(idref,resour,tit,asukoht)
	for bcd in item.childNodes:
		if bcd.nodeType == 1 and bcd.nodeName == 'item':
			temp = tit
                        self.otsiWikid(bcd,tiitel,asukoht,resour,vanem=temp)
	return

    def leiaLahendus(self,target,tiitel,asukoht='',resour='',params=''):
	try:
		xmlbase = self.get_attr(target,'xml:base')
	except:
		xmlbase = ''
	type = self.get_attr(target,'type')
	href = self.get_attr(target,'href')
	if params == 'wikifolder' and not self.testonly:
		wiki_resour = target.getElementsByTagName('resources')[0]
#		for wiki_items in target.getElementsByTagName('item'):
		#XXX: we try and except since something happened here what should not happen
		try:
			wiki_items = target.getElementsByTagName('item')[0]
		except IndexError:
			return
		self.otsiWikid(wiki_items,tiitel,asukoht,wiki_resour,start=1)
                return
	if re.search('webcontent',type) and not self.testonly: # lheb raamaturiiulile
#	        temp = getattr(self.iva.courses, self.kursus.get_id())
#	        asukoht = getattr(temp, 'gf')
		self.handleResource(target,asukoht,resour,tiitel)
	if re.search('file',type) or re.search('memo',type) or re.search('URL',type) or re.search('wiki',type):
		if not self.testonly:
			print "testonly: ",self.testonly
			self.handleResource(target,asukoht,resour,tiitel)
	if re.search('Calenda',type) and not self.testonly:
		self.lisaSyndmus(target,tiitel)
	if re.search('imscp',type):
		if not self.kursus: 
			self.kursus = self.coursemanager
		abc = Importer(self.uname,self.iva,xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly,kasuta_jooksvat=self.kasuta_jooksvat,testonly=self.testonly)
		failisisu = abc.loadFile(self.prefix+xmlbase+href)
		abc.processFile(self.kursus,failisisu)
		self.processed.append(target)
	if re.search('imsqti',type):
		abc = Importer(self.uname,self.iva,self.prefix+xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly,kasuta_jooksvat=self.kasuta_jooksvat,testonly=self.testonly)
		failisisu = abc.loadFile(self.prefix+xmlbase+href)
		abc.processFile(self.kursus,failisisu)
		self.processed.append(target)
	if re.search('meediapaja',type) or re.search('teadmuspaja',type) or params == 'Assignments' and not self.testonly:
		abc = Importer(self.uname,self.iva,self.prefix+xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly,kasuta_jooksvat=self.kasuta_jooksvat,testonly=self.testonly)
		failisisu = abc.loadFile(self.prefix+xmlbase+href)
		abc.processFile(self.kursus,failisisu)
		self.processed.append(target)
	if re.search('SYNDMUSED',tiitel) and not self.testonly:
		self.ImportUserEvents(target,tiitel)
	if params == 'RAAMATURIIUL' and not self.testonly:
		r_res = target.getElementsByTagName('resources')[0]
		for r_org in target.getElementsByTagName('organization'):
			self.otsiTOC(r_org, r_res)
	if params == 'RYHMALAUAD' and not self.testonly:
		tmpasukoht = self.riiuliasukoht
		self.riiuliasukoht = getattr(self.kursus,'subgroups')
		r_res = target.getElementsByTagName('resources')[0]
		for r_org in target.getElementsByTagName('organization'):
			self.otsiTOC(r_org, r_res,subgroup=1)
		self.riiuliasukoht = tmpasukoht
	if params == 'SISEGRUPP' and not self.testonly:
		tmpasukoht = self.riiuliasukoht
		self.riiuliasukoht = getattr(self.kursus,'subgroups')
		s_res = target.getElementsByTagName('resources')[0]
		for s_org in target.getElementsByTagName('organization'):
			s_nimi = self.get_attr(s_org,'identifier').split(':')[1]
			s_nimi=re.sub('[^a-zA-Z0-9]', '_', s_nimi)
			if s_nimi[0] == "_": s_nimi="x"+s_nimi
			if s_nimi[-2:] == "__": s_nimi += "x"
			if not hasattr(self.riiuliasukoht.aq_inner.aq_self, s_nimi):
				print "teen gruppi!",s_nimi
				self.kursus.lisa_grupp(s_nimi)
			#XXX:subgroup name mapping!
			try:
				self.riiuliasukoht = getattr(self.riiuliasukoht.aq_inner.aq_self, s_nimi)
			except AttributeError:
				self.riiuliasukoht = self.kursus.lisa_grupp(s_nimi)
			self.otsiTOC(s_org,s_res)
		self.riiuliasukoht = tmpasukoht
	if params == 'KASUTAJATE WEBTOPID' or params == 'KASUTAJATE SAHTLID' and not self.testonly:
		tmpasukoht = self.riiuliasukoht
		u_res = target.getElementsByTagName('resources')[0]
		for u_org in target.getElementsByTagName('organization'):
			u_ident = self.get_attr(u_org,'identifier').split('_')[1]
			self.owner = u_ident
			#XXX: we didn't export admin in previous versions and we're in 
			#     trouble now ;(
			if not hasattr(self.kursus.fle_users, u_ident):
				continue
			if params == 'KASUTAJATE SAHTLID':
				tmp = getattr(self.kursus.fle_users, u_ident).webtop
			else:
				tmp = getattr(self.kursus.fle_users, u_ident).webtop
			if not hasattr(tmp, 'c'+str(self.kursus.id)):
				cf = tmp.lisa_kursuse_kaust_ilma_requestita(self.owner,str('c'+str(self.kursus.id)))
				self.set_omanik(cf,self.owner)
			self.riiuliasukoht = getattr(tmp, 'c'+str(self.kursus.id)) 
			self.otsiTOC(u_org, u_res)
		self.owner = self.uname
		self.riiuliasukoht = tmpasukoht
	return

    def otsiTarget(self,identifier,ressursid,tiitel,asukoht='',params=''):
	for target in ressursid.getElementsByTagName("resource"):
		id = self.get_attr(target,'identifier')
		if id == identifier and not self.vaataKasTehtud(target):
			self.leiaLahendus(target,tiitel,asukoht,ressursid,params)
			self.processed.append(target)
			return
		if id == identifier and self.vaataKasTehtud(target):
			#print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!! target1"
			pass
	for target in self.root.getElementsByTagName("manifest"):
		id = self.get_attr(target,'identifier')
		if id == identifier and not self.vaataKasTehtud(target):
			self.leiaLahendus(target,tiitel,asukoht,ressursid,params=params)
			self.processed.append(target)
			return
		if id == identifier and self.vaataKasTehtud(target):
			#print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!! target2"
			pass
	for target in self.root.getElementsByTagName("organization"):
		id = self.get_attr(target,'identifier')
		if id == identifier and not self.vaataKasTehtud(target):
			self.leiaLahendus(target,tiitel,asukoht,ressursid,params=params)
			self.processed.append(target)
			return
		if id == identifier and self.vaataKasTehtud(target):
			pass
			#print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!!otsiTarget3"
	#print "identifieri " + identifier + " pole vimalik leida"
	return

    def otsiTOC(self,element,ressursid,subgroup=0):
	#XXX:keyword subgroup should go away, it's needed to import iva ver 0.4.2 subgroup portfolios
	for target in element.childNodes:
		if not target.nodeName == 'item':
			continue
		identifier = self.get_attr(target,'identifier')
		try:
			identifierref = self.get_attr(target,'identifierref')
		except:
			identifierref = ''
		try:
			params = self.get_attr(target,'parameters')
		except:
			params = ''
		tiitel = self.get_text(target.getElementsByTagName('title')[0])
		try:
			orgID = self.get_attr(target.getElementsByTagName('title')[0],'originalID')
		except:
			orgID = ''
		try:
			orgOwner = self.get_attr(target.getElementsByTagName('title')[0],'originalOwner')
		except:
			orgOwner = ''
		if self.vaataKasTehtud(target):
			continue
		else:
			self.processed.append(target)
		if identifierref:
			if params == 'wikifolder':
				tmp = self.riiuliasukoht
				self.riiuliasukoht = self.riiuliasukoht.add_wiki(tiitel)
				self.add_folder_metadata(self.riiuliasukoht,target)
				if orgOwner:
					self.set_omanik(self.riiuliasukoht, orgOwner)
				else:
					self.set_omanik(self.riiuliasukoht, self.owner)
			self.otsiTarget(identifierref, ressursid, tiitel,asukoht=self.riiuliasukoht,params=params)
			if params == 'wikifolder':
				self.riiuliasukoht = tmp
		else:
			#XXX:That's freaky stuff.
			if not subgroup:
				if not self.testonly:
					self.riiuliasukoht = self.createFolder(self.riiuliasukoht, tiitel,orgID,orgOwner)
					self.add_folder_metadata(self.riiuliasukoht,target)
			else:
				m = self.riiuliasukoht.objectValues()
				korras = 0
				for x in m:
					if x.get_id() == tiitel:
						self.riiuliasukoht = getattr(self.riiuliasukoht, x.get_id())
						korras = 1
						break
				if not korras:
					self.riiuliasukoht = self.kursus.lisa_grupp(tiitel)
			#self.riiuliasukoht = getattr(self.riiuliasukoht, kaust)
			self.otsiTOC(target, ressursid)
			if not self.testonly:
				self.riiuliasukoht = self.riiuliasukoht.aq_parent
	return

    def processZip2(self):
	""" ... """
	kaustad = []
	abc = self.root.getElementsByTagName("organizations")[0]
	for i in abc.getElementsByTagName("organization"):
		kaustad.append(self.get_attr(i,'xml:base'))
	return kaustad

    def vaataKasTehtud(self,element):
	for abc in self.processed:
		if element.isSameNode(abc):
			return 1
	return 0

    def otsiKasKasutajaid(self,element):
	try:
		res_xmlbase = self.get_attr(element,'xml:base')
	except:
		res_xmlbase = ''
	for res in element.getElementsByTagName('resource'):
		if re.search('imsent',self.get_attr(res,'type')) and not self.vaataKasTehtud(res):
			try:
				xmlbase = self.get_attr(res,'xml:base')
			except:
				xmlbase = ''
			try:
				href = self.get_attr(res.getElementsByTagName('file')[0],'href')
			except:
				return
			

	                abc = Importer(self.uname,self.iva,self.prefix+xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly,kasuta_jooksvat=self.kasuta_jooksvat,testonly=self.testonly)
        	        failisisu = abc.loadFile(self.prefix+xmlbase+href)
                	abc.processFile(self.kursus,failisisu)

#			self.importUsers(res)
			self.processed.append(res)
			if not failisisu:
				failisisu = ''
			return failisisu
	for res in self.root.getElementsByTagName('resource'):
                if re.search('imsent',self.get_attr(res,'type')) and not self.vaataKasTehtud(res):
#			self.importUsers(res)
#			self.processed.append(res)
                        abc = Importer(self.uname,self.iva,self.prefix+xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly,kasuta_jooksvat=self.kasuta_jooksvat,testonly=self.testonly)
                        failisisu = abc.loadFile(self.prefix+xmlbase+href)
                        abc.processFile(self.kursus,failisisu)
                        self.processed.append(res)
                        return failisisu
	return

    def otsiAlgandmed(self,elem):
	try:
		metadata = elem.getElementsByTagName("metadata")[0]
	except:
		pass
		#raise 'IVA Error','Missing toplevel-manifest metadata element'
	try:
		resources = elem.getElementsByTagName("resources")[0]
	except:
		pass
		#raise 'IVA Error','Missing toplevel-manifest resources element'
	try:
		organizations = elem.getElementsByTagName("organizations")[0]
	except:
		raise 'IVA Error','Missing toplevel-manifest organizations element'
	return metadata, organizations, resources

    def processFile(self,coursemanager,element):
	""" process zip and find anything usable. """
	proc_alg = time.time()
	self.owner = self.uname
	self.coursemanager = coursemanager
	i = 0
	kas_kursus = 0
	#for organizations in self.root.getElementsByTagName("organizations"):
	#self.kursus = self.createCourse(self.root.getElementsByTagName('metadata')[0],coursemanager,uname)
	st_elem = element.firstChild
	self.root = element.firstChild
	
#	return
	success = self.kontrolliEsimeneElement(st_elem,coursemanager)
	if success:
		return
	# Siit edasi eeldame, et tegemist on CP-ga
	ok = 0
	j = 0
	try:
		st_elem = element.getElementsByTagName("manifest")[0]
	except IndexError:
		print "XXX:for now, we totally failed reading file."
		return
	self.root = st_elem

	metadata,orgnz, resources = self.otsiAlgandmed(st_elem)

	if not self.userwikionly and not self.testonly and not self.kasuta_jooksvat:
		kas_kursus = self.createCourse(metadata,coursemanager,self.uname)
	if kas_kursus:
		self.kursus = kas_kursus
		self.riiuliasukoht = getattr(self.kursus, 'gf')
	else:
		self.riiuliasukoht = ''
		#print "sellest failist ei saanud kursust teha\nProovin kasutada jooksvat kursust"
	if self.userwikionly:
		self.riiuliasukoht = self.userwikionly
	if self.kasuta_jooksvat:
		self.riiuliasukoht = getattr(self.kursus, 'gf')
	failisisu = self.otsiKasKasutajaid(resources)
	for org in orgnz.childNodes:
		if org.nodeName == 'organization':
			self.otsiTOC(org,resources)
	# kursus ja sisegrupid peaksid olema nd loodud. paigutan kasutajad.
	if failisisu and not self.userwikionly and not self.testonly and not self.kasuta_jooksvat:
		self.restoreMembership(failisisu)
	proc_lopp = time.time()
	print "Process Zip:",proc_lopp-proc_alg


    def loadZip(self,file):
        zip = zipfile.ZipFile(file,"r",zipfile.ZIP_DEFLATED)

        for name in zip.namelist():
	#    if not re.search('imsmanifest.xml',name):
                self.binarydata.restoreData(name,zip.read(name))
        zip.close()


    def loadFile(self,nimi):
	xmlstring = self.binarydata.getData(nimi)
	print "loen faili: ",nimi
	try:
		fish = xml.dom.minidom.parseString(xmlstring)
	except UnicodeError, ExpatError:
		print "XML data is not utf-8 encoded! Detecting encoding..."
		encoding = re.search('encoding="([-a-zA-Z0-9]*)">',xmlstring).group(1)
		print "Transforming from %s to utf-8..." % encoding
		xmlstring = unicode(xmlstring,encoding).encode("utf-8")
		fish = xml.dom.minidom.parseString(xmlstring)
	return fish 

    def kontrolliEsimeneElement(self,element,courses):
	if self.testonly and element.nodeName!='questestinterop':
		try:
			element = element.getElementsByTagName("questestinterop")[0]
		except:
			pass
	if element.nodeName =='MailMessages':
		if self.userwikionly or self.testonly:
			return "kala"
		self.importMailMessages(element)
		return "MM"
	if element.nodeName == 'CourseCats':
		if self.userwikionly or self.testonly:
			return "kala"
		self.importCourseCats(element)
		return "CC"
	if element.nodeName == 'questestinterop':
		if self.userwikionly:
			return "kala"
		#Jump to qti import
		self.importQT(element,self.kursus,self.uname)
		return "QT"
	if element.nodeName == 'enterprise':
		if self.userwikionly or self.testonly:
			return "kala"
		#FIX: 1st element is DocumentType
		abc = element.nextSibling
		if not self.kasuta_jooksvat:
			self.importUsers(abc)
		else:
			print "users not imported"
		#Jump to user import
		return "EP"
	if element.nodeName == 'Assignments':
		if self.userwikionly or self.testonly:
			return "kala"
		self.importKodutood(element)
		return "Ass"
	if element.nodeName == 'Jamming':
		if self.userwikionly or self.testonly:
			return "kala"
		print " import Jamming"
		kala = Exporter(self.iva,prefix=self.prefix)
		kala.binarydata = self.binarydata
		kala.importJamming(element,self.kursus)
		return "MP"
	if element.nodeName == 'KnowledgeBuilding':
		if self.userwikionly or self.testonly:
			return "kala"
		print " import KnowledgeBuilding"
		kala = Exporter(self.iva,prefix=self.prefix)
		kala.binarydata = self.binarydata
		for ctx in element.childNodes:
			kala.importContext(ctx,self.kursus)
		return "TP"
	return 0


class kirjutaYldM:
    def __init__(self):
	self.mainmani = Document()
	self.root_element = self.mainmani.createElement("manifest")
        self.root_element.setAttribute('identifier','IVA')
        self.root_element.setAttribute('version','1')
        self.root_element.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
        self.root_element.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        self.root_element.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
        self.root_element.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
	self.mainmani.appendChild(self.root_element)
	md=self.mainmani.createElement("metadata")
	self.root_element.appendChild(md)
	mds=self.mainmani.createElement('schema')
        md.appendChild(mds)
        text = self.mainmani.createTextNode('IMS Content')
        mds.appendChild(text)
        mdv=self.mainmani.createElement('schemaversion')
        md.appendChild(mdv)
        mdv.appendChild(self.mainmani.createTextNode('1.1'))
        rek = self.mainmani.createElement('imsmd:record')
	md.appendChild(rek)
        gen = self.mainmani.createElement('imsmd:general')
        rek.appendChild(gen)
        tit = self.mainmani.createElement('imsmd:title')
        gen.appendChild(tit)
        lang = self.mainmani.createElement('imsmd:langstring')
        lang.setAttribute('xml:lang','en-US')
        lang.appendChild(self.mainmani.createTextNode('Data exported from IVA. See http://www.htk.tpu.ee/iva'))
        tit.appendChild(lang)

	self.organizations = self.mainmani.createElement("organizations")
	self.root_element.appendChild(self.organizations)
	self.organization = self.mainmani.createElement("organization")
	self.organization.setAttribute('identifier','courses')
	self.organizations.appendChild(self.organization)
	self.ress = self.mainmani.createElement("resources")
	self.root_element.appendChild(self.ress)


    def kirjutaYldmanifest(self, kursusenr=0, kirjeldus='kirjeldus',tyyp='imscp_xmlv1p1p3',base='course/',href='imsmanifest.xml'):
        m = self.mainmani.createElement("item")
	m.setAttribute('identifier','item_'+str(kursusenr))
	m.setAttribute('identifierref','resource_'+str(kursusenr))
#        m.setAttribute('identifier','course'+str(kursusenr))
        self.organization.appendChild(m)
	title = self.mainmani.createElement("title")
	title.appendChild(self.mainmani.createTextNode(kirjeldus))
	m.appendChild(title)
	item = self.mainmani.createElement("resource")
	item.setAttribute('identifier','resource_'+str(kursusenr))
	item.setAttribute('type',tyyp)
	if base != "":
		item.setAttribute('xml:base',base)
	item.setAttribute('href',href)
	item_title = self.mainmani.createElement('file')
	item_title.setAttribute('href',href)
	item.appendChild(item_title)
	self.ress.appendChild(item)
        return m

    def lisaFaili(self, failinimi="ivaarhiiv.zip"):
        "Lisatakse yldmanifest zip'i"
        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        self.mainmani.writexml(dump)
        zip.writestr(zipfile.ZipInfo("imsmanifest.xml"),dump.getdata())
	zip.close()



class Kirjutus:
    import string
    def __init__(self, ivajuur, kursusenr):
	""" Uue eksportkirjutaja loomine. Parameetrina eksporditava iva juurobjekt """
	self.generateID()	# just in case
	self.iva = ivajuur
	if kursusenr != None and kursusenr != 0:
		self.kursus = getattr(ivajuur.courses, str(kursusenr))
		self.kursusenr = kursusenr
	else:
		self.kursusenr = 0
		self.kursus = None
	return

    def looKursuseFail(self,metadata=1):
	# kursuse faili loomine
	# must be called before other functions
	self.binarydata = DataTable()
        self.idmap = {}
        self.dom=Document()
        self.loendur=Counter()
# valmistame ette dokumendi 
        self.root=self.dom.createElement("manifest")
	self.dom.appendChild(self.root)
        self.root.setAttribute('identifier','IVA')
        self.root.setAttribute('version','1')
        self.root.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
        self.root.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        self.root.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	self.root.setAttribute('xmlns:ivamd','http://www.htk.tpu.ee/%7Evahur/ivaplus.xsd')
        self.root.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd http://www.htk.tpu.ee/%7Evahur/ivaplus http://www.htk.tpu.ee/%7Evahur/ivaplus.xsd')
	if metadata:
		metadata = self.dom.createElement("metadata")

		schema = self.dom.createElement("schema")
		schema_data = self.dom.createTextNode("IMS Content")
		schema.appendChild(schema_data)
		schema_ver = self.dom.createElement("schemaversion")
		schema_ver_data = self.dom.createTextNode("1.1")
		schema_ver.appendChild(schema_ver_data)
	
		metadata.appendChild(schema)
		metadata.appendChild(schema_ver)

		md_methods = self.dom.createElement('ivamd:methods')
		md_methods_data = self.dom.createTextNode(self.kursus.get_methods())
		md_methods.appendChild(md_methods_data)
		metadata.appendChild(md_methods)
		md_organisation = self.dom.createElement('ivamd:organisation')
		md_organisation_data = self.dom.createTextNode(self.kursus.get_organisation())
		md_organisation.appendChild(md_organisation_data)
		metadata.appendChild(md_organisation)
		md_quote = self.dom.createElement('ivamd:quote')
		md_quote_data = self.dom.createTextNode(self.kursus.kysiTekst())
		md_quote.appendChild(md_quote_data)
		metadata.appendChild(md_quote)
		if self.kursus.kysiLogo():
			md_picture = self.dom.createElement('ivamd:picture')
			name = self.binarydata.storeData(self.kursus.kysiLogo())
			md_picture.setAttribute('href',name)
			metadata.appendChild(md_picture)
		md_status = self.dom.createElement('ivamd:status')
		try:
			md_status_data = self.dom.createTextNode(str(self.kursus.staatus))
		except:
			md_status_data = self.dom.createTextNode(str(0))
		md_status.appendChild(md_status_data)
		metadata.appendChild(md_status)

		record = self.dom.createElement('imsmd:record')
		general = self.dom.createElement('imsmd:general')
		record.appendChild(general)
		title = self.dom.createElement('imsmd:title')
		general.appendChild(title)
		lang = self.dom.createElement('imsmd:langstring')
		lang.setAttribute('xml:lang','en-US')
		lang_data = self.dom.createTextNode(self.kursus.get_name())
		lang.appendChild(lang_data)
		title.appendChild(lang)

		descr = self.dom.createElement('imsmd:description')
		descrlang = self.dom.createElement('imsmd:langstring')
		descrlang.setAttribute('xml:lang','en-US')
		descrlang_data = self.dom.createTextNode(self.kursus.get_description())
		descrlang.appendChild(descrlang_data)
		descr.appendChild(descrlang)
		general.appendChild(descr)
		metadata.appendChild(record)

		org = self.dom.createElement('organization_sec')
		org_data = self.dom.createTextNode(str(self.kursus.getCourseCategory()))
		org.appendChild(org_data)
		metadata.appendChild(org)

		score = self.dom.createElement('score')
		score_data = self.dom.createTextNode(self.kursus.get_credits())
		score.appendChild(score_data)
		metadata.appendChild(score)
		
		code = self.dom.createElement('code')
		code_data = self.dom.createTextNode(self.kursus.get_courseID())
		code.appendChild(code_data)
		metadata.appendChild(code)
		
		start = self.dom.createElement('start_time')
		start_data = self.dom.createTextNode(str(self.kursus.get_start_date()))
		start.appendChild(start_data)
		metadata.appendChild(start)
		
		end = self.dom.createElement('end_time')
		end_data = self.dom.createTextNode(str(self.kursus.get_end_date()))
		end.appendChild(end_data)
		metadata.appendChild(end)
		
		self.root.appendChild(metadata)
	
	self.organizations = self.dom.createElement('organizations')
	self.organization = self.dom.createElement('organization')
	self.organization.setAttribute('identifier','IVA_CONTENT'+str(self.idnumber))
	self.organizations.appendChild(self.organization)
	self.resources = self.dom.createElement('resources')
	self.root.appendChild(self.organizations)
	self.root.appendChild(self.resources)
	

    def generateID(self):
	# generates idnumber. used as identifer and identifierref
	# used as 'ITEM'+str(self.idnumber) and 'TARGET'+str(self.idnumber)
	import random
	self.idnumber = str(random.randint(1,9999))+"_"+str(random.randint(1,9999))
	return self.idnumber

    def lisaMetadata(self,vanem,objekt,technical='',annotations=''):
	metadata = self.dom.createElement('metadata')
	try:
		metadata.setAttribute('creationtime',str(objekt.get_timestamp()))
	except AttributeError:
		pass
	if technical:
		technical = self.dom.createElement('imsmd:technical')
		format = self.dom.createElement('imsmd:format')
		try:
			format_data = self.dom.createTextNode(str(objekt.content_type))
		except:
			format_data = self.dom.createTextNode('text/plain')
		format.appendChild(format_data)
		technical.appendChild(format)
		
		perm = self.dom.createElement('permission')
                technical.appendChild(perm)

                status = self.dom.createElement('status')
		try:
			o_perm = objekt.getObjPermission()
		except AttributeError:
			o_perm = 10
                status.appendChild(self.dom.createTextNode(str(10)))
                perm.appendChild(status)

                order = self.dom.createElement('position')
		try:
			o_wei = objekt.weight
		except AttributeError:
			o_wei = 1000
                order.appendChild(self.dom.createTextNode(str(o_wei)))
                perm.appendChild(order)

                docStatus = self.dom.createElement('docstatus')
		try:
			o_doc_s = objekt.getDocStatus()
		except AttributeError:
			o_doc_s = 0
                docStatus.appendChild(self.dom.createTextNode(str(o_doc_s)))
                perm.appendChild(docStatus)

                #userRating!?
		try:
	                uca = self.dom.createElement('commentable')
       	        	uca.setAttribute('view',str(objekt.isCommentsVisible()))
       	        	uca.appendChild(self.dom.createTextNode(str(objekt.isCommentable())))
	                perm.appendChild(uca)
		except AttributeError:
			pass

		try:
	                ura = self.dom.createElement('rateable')
	                ura.setAttribute('view',str(objekt.isRatingVisible()))
	                ura.appendChild(self.dom.createTextNode(str(objekt.isRateable())))
	                perm.appendChild(ura)
		except AttributeError:
			pass

		try:
	                time = self.dom.createElement('timelimits')
        	        time.setAttribute('start',str(objekt.getStartTime()))
                	time.setAttribute('end',str(objekt.getEndTime()))
                	time.appendChild(self.dom.createTextNode(str(objekt.getTimeFunc())))
                	perm.appendChild(time)
		except AttributeError:
			pass

		try:
	                for up in objekt.listLocalUserRoles('Items'):
	                        granted = self.dom.createElement('granted')
	                        granted.appendChild(self.dom.createTextNode(str(up)))
	                        perm.appendChild(granted)
		except AttributeError:
			pass
		
		metadata.appendChild(technical)
        if annotations:
                for x in objekt.getComments():
                        an = self.dom.createElement('annotation')
                        an.setAttribute('parameters','comment')
                        metadata.appendChild(an)
                        person = self.dom.createElement('person')
                        person.appendChild(self.dom.createTextNode(str(x[0])))
                        an.appendChild(person)
                        date = self.dom.createElement('date')
                        date.appendChild(self.dom.createTextNode(str(x[2])))
                        an.appendChild(date)
                        desc = self.dom.createElement('description')
                        desc.appendChild(self.dom.createTextNode(str(x[4])))
                        an.appendChild(desc)
                        #XXX:not compilant
                        stat = self.dom.createElement('status')
                        stat.appendChild(self.dom.createTextNode(str(x[1])))
                        an.appendChild(stat)
                        value = self.dom.createElement('value')
                        value.appendChild(self.dom.createTextNode(str(x[3])))
                        an.appendChild(value)


	vanem.appendChild(metadata)
	return metadata

    def kirjutaItem(self,vanem,isvisible='',parameters='',tiitel='',no_ref=0,originalID='',originalOwner='',realObject=None, realname=''):
	# writes an item tag and appends to vanem
	item = self.dom.createElement('item')
	item.setAttribute('identifier','ITEM'+str(self.idnumber))
        if realObject is not None and realObject.kasEsitluskaust():
                item.setAttribute('presentation',str(realObject.kasEsitluskaust()))
	if not no_ref:
		item.setAttribute('identifierref','TARGET'+str(self.idnumber))
        if realObject:
                md = self.dom.createElement('metadata')
		try:
			md.setAttribute('creationtime',str(realObject.get_timestamp()))
		except AttributeError:
			pass
                item.appendChild(md)
                if hasattr(realObject.aq_self, 'kylastused'):
                        for x in realObject.aq_self.kylastused.keys():
                                an = self.dom.createElement('annotation')
                                an.setAttribute('parameters','visit')
                                md.appendChild(an)
                                ps = self.dom.createElement('person')
                                ps.appendChild(self.dom.createTextNode(str(x)))
                                an.appendChild(ps)
                                dt = self.dom.createElement('date')
                                dt.appendChild(self.dom.createTextNode(str(realObject.aq_self.kylastused[x])))
                                an.appendChild(dt)

                perm = self.dom.createElement('permission')
                md.appendChild(perm)

                status = self.dom.createElement('status')
                status.appendChild(self.dom.createTextNode(str(realObject.getObjPermission())))
                perm.appendChild(status)

                order = self.dom.createElement('position')
                order.appendChild(self.dom.createTextNode(str(realObject.weight)))
                perm.appendChild(order)

                time = self.dom.createElement('timelimits')
                time.setAttribute('start',str(realObject.getStartTime()))
                time.setAttribute('end',str(realObject.getEndTime()))
                time.appendChild(self.dom.createTextNode(str(realObject.getTimeFunc())))
                perm.appendChild(time)

                for up in realObject.listLocalUserRoles('Items'):
                        granted = self.dom.createElement('granted')
                        granted.appendChild(self.dom.createTextNode(str(up)))
                        perm.appendChild(granted)

	if isvisible != '':
		item.setAttribute('isvisible',isvisible)
	if parameters != '':
		item.setAttribute('parameters',parameters)
	if tiitel != '':
		self.kirjutaTitle(item,tiitel,originalID=originalID,originalOwner=originalOwner, realname=realname)
	vanem.appendChild(item)
	return item

    def kirjutaResource(self,vanem,tyyp='webcontent',fail='', href='',base=''):
	# writes resource tag and appends to vanem
	resource = self.dom.createElement('resource')
	resource.setAttribute('identifier','TARGET'+str(self.idnumber))
	resource.setAttribute('type',tyyp)
	if base != '':
		resource.setAttribute('xml:base',base)
	if href != '':
		resource.setAttribute('href',str(href))
	if fail != '':
		self.kirjutaFile(resource,fail)
	vanem.appendChild(resource)
	return resource

    def kirjutaTitle(self,vanem,tiitel,namespace='',originalID='',originalOwner='', realname=''):
        title = self.dom.createElement(namespace+'title')
        if originalID:
                #XXX: THIS IS NOT IMS VALID!
                title.setAttribute('originalID',originalID)
        if originalOwner:
                #XXX: THIS IS NOT IMS VALID!
                title.setAttribute('originalOwner',originalOwner)
	if realname:
		title.setAttribute('realname', realname)
        title_data = self.dom.createTextNode(tiitel)
        title.appendChild(title_data)
        vanem.appendChild(title)
        return title

    def kirjutaFile(self,vanem,fail):
	fail_elem = self.dom.createElement('file')
	fail_elem.setAttribute('href',fail)
	vanem.appendChild(fail_elem)
	return fail_elem

    def kirjutaDependency(self,vanem,targetid):
	dep = self.dom.createElement('dependency')
	dep.setAttribute('identifierref','TARGET'+str(targetid))
	vanem.appendChild(dep)
	return dep

    def kirjutaManifest(self,base=''):
	# creates sub-manifest, returns 3 elements: metadata, organizations and resources
	manifest = self.dom.createElement('manifest')
	manifest.setAttribute('identifier','TARGET'+str(self.idnumber))
	if base != '':
		manifest.setAttribute('xml:base',base)
	metadata = self.dom.createElement('metadata')
	manifest.appendChild(metadata)
	organizations = self.dom.createElement('organizations')
	manifest.appendChild(organizations)
	resources = self.dom.createElement('resources')
	manifest.appendChild(resources)
	self.root.appendChild(manifest)
	return metadata,organizations,resources

    def otsiWebtopItemid(self,folder,itemid,resource,start=0):
	targetid = self.generateID()
	prms = ''
	if folder.kasWikiKaust():
		prms = 'wikifolder'
	if not start:
		item = self.kirjutaItem(itemid,parameters=prms,no_ref=1,realObject=folder)
		self.kirjutaTitle(item,folder.get_name(),originalID=folder.getId(),originalOwner=folder.getOwnerTuple()[1])
	else:
		item = itemid
	for obj in folder.list_contents(criteria='weight'):
		print obj.absolute_url()
		targetid = self.generateID()
		if obj.meta_type != 'WebtopFolder':
			ii = self.kirjutaItem(item)
			self.kirjutaTitle(ii, obj.get_name(),originalID=obj.getId(),originalOwner=obj.getOwnerTuple()[1])
		if obj.meta_type == 'WebtopFile':
			res = self.kirjutaResource(resource,tyyp='file')
			fnimi = self.binarydata.storeData(obj.data,'file')
			fail = self.kirjutaFile(res,fnimi)
			metadata = self.lisaMetadata(fail,obj, technical=1,annotations=1)
			self.kirjutaTitle(metadata,obj.get_name(),'imsmd:',originalID=obj.getId(),originalOwner=obj.getOwnerTuple()[1], realname=obj.get_realname())
		if obj.meta_type == 'WebtopLink':
			res = self.kirjutaResource(resource,tyyp='URL')
			fail = self.kirjutaFile(res,obj.get_url())
			metadata = self.lisaMetadata(fail,obj,technical=1,annotations=1)
			self.kirjutaTitle(fail,obj.get_name(),'imsmd:',originalID=obj.getId(),originalOwner=obj.getOwnerTuple()[1])
		if obj.meta_type == 'WebtopMemo':
			res = self.kirjutaResource(resource,tyyp='memo')
			mnimi = self.binarydata.storeData(obj.get_body(),'memo')
			file = self.kirjutaFile(res,mnimi)
			metadata = self.lisaMetadata(file,obj,technical=1,annotations=1)
			self.kirjutaTitle(file,obj.get_name(),'imsmd:',originalID=obj.getId(),originalOwner=obj.getOwnerTuple()[1])
		if obj.meta_type == 'WebtopFolder':
			targetid = self.generateID()
			if obj.kasWikiKaust():
				self.kirjutaWiki(obj, 'ident',obj.aq_inner.get_name(),obj.wikiKaustEsimeneLeht(),item)
			else:
				self.otsiWebtopItemid(obj,item,resource)
#	for fol in folder.objectValues('WebtopFolder'):
		#if fol.kasWikiKaust():
			# XXX wiki kirjutamine!?
		#	self.kirjutaWiki(fol, 'ident', fol.get_name(),fol.wikiKaustEsimeneLeht(),item)
		#else:
#		self.otsiWebtopItemid(fol,item,resource)
	return

    def kirjutaWebtop(self,point,misc='ident',tiitel='SISEGRUPP'):
	# exports webtop style components
	self.generateID()
	self.kirjutaItem(self.organization,tiitel=tiitel, parameters=tiitel)
	e_metadata,e_organizations,e_resources = self.kirjutaManifest()
	organization = self.dom.createElement('organization')
#	organization.setAttribute('identifier',misc+str(self.idnumber))
	organization.setAttribute('identifier',misc)
	e_organizations.appendChild(organization)
	self.otsiWebtopItemid(point,organization,e_resources,start=1)
	return

    def kirjutaKasutajaWebtop(self,kasutajad):
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='KASUTAJATE WEBTOPID',parameters='KASUTAJATE WEBTOPID')
	w_metadata,w_organizations,w_resources = self.kirjutaManifest()
#	self.generateID()
#	self.kirjutaItem(self.organization,tiitel='KASUTAJATE SAHTLID',parameters='KASUTAJATE SAHTLID')
#	s_metadata,s_organizations,s_resources = self.kirjutaManifest()
	for user in kasutajad:
		uname = user.get_uname()
		try:
			pp = getattr(self.iva.fle_users, uname)
			point = getattr(pp.webtop, 'c'+self.kursusenr)
			webtop_ation = self.dom.createElement('organization')
			webtop_ation.setAttribute('identifier','user_'+str(uname)+'_webtop')
			w_organizations.appendChild(webtop_ation)
			self.otsiWebtopItemid(point,webtop_ation,w_resources,start=1)
		except:
			pass
#		try:
#			point = getattr(pp.sahtel, 'c'+self.kursusenr)
#			sahtel_ation = self.dom.createElement('organization')
#			sahtel_ation.setAttribute('identifier','user_'+str(uname)+'_sahtel')
#			s_organizations.appendChild(sahtel_ation)
#			self.otsiWebtopItemid(point,sahtel_ation,s_resources,start=1)
#		except:
#			pass
	return

    def pakiKursusFaili(self,failinimi,path='ABCDE'):
	import string
	if path == 'ABCDE':
		path = str(self.kursusenr)
	if path != '':
		path += '/'
	if zipfile.is_zipfile(failinimi):
		zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
	else:
		zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	dump = Dump()
	self.dom.writexml(dump)
	zip.writestr(zipfile.ZipInfo(path+"imsmanifest.xml"),dump.getdata())
	
	for name in self.binarydata.names:
		zip.writestr(
		  zipfile.ZipInfo(path+name),
		  str(self.binarydata.getData(name)))
	zip.close()


    def otsiWikiLapsed(self,point,resources,organization,start='WikiStart',sygavus=99999):
	#puudub koht muutjate jaoks
	for wiki in self.wikid:
		wiki_vanemad = wiki[1]
		if start in wiki_vanemad:
			self.generateID()
			wikileht = getattr(point, wiki[0])
			item = self.kirjutaItem(organization,parameters='ZWiki',tiitel=wikileht.name())
			wname = self.binarydata.storeData(wikileht,'wiki')
			self.kirjutaResource(resources,'wikipage',wname)
			if not self.wikilevel == sygavus:
				self.wikilevel = self.wikilevel+1
				self.otsiWikiLapsed(point, resources, item, wikileht.name(),sygavus)
				self.wikilevel = self.wikilevel-1
	for wiki in self.wiki_pildid:
		self.generateID()
		wiki_pilt = getattr(point, wiki)
		if wiki_pilt.meta_type == 'Image': 
			tyyp = 'wikiimage'
		if wiki_pilt.meta_type == 'File':
			tyyp = 'wikifile'
		item = self.kirjutaItem(organization, parameters='ZWiki',tiitel=wiki_pilt.id())
		wname = self.binarydata.storeData(wiki_pilt.data,tyyp)
		res = self.kirjutaResource(resources,tyyp=tyyp)
		fail = self.kirjutaFile(res,wname)
		metadata = self.lisaMetadata(fail,wiki_pilt, technical=1)
		#print wiki_pilt.getContentType()
		
	self.wiki_pildid = []
	return

    def indekseeriWikid(self,point):
	self.wikid = []
	self.wiki_pildid = []
	temp = []
	#for wiki in point.objectValues('ZWiki Page'):
	for wiki in point.objectValues():
		if wiki.meta_type == 'ZWiki Page':
			try:
				temp.append(wiki.name())
				temp.append(wiki.parents)
				self.wikid.append(temp)
				temp = []
			except:
				pass
		if wiki.meta_type == 'Image' or wiki.meta_type == 'File':
			self.wiki_pildid.append(wiki.id())
		#print wiki.__name__+" "+wiki.meta_type
	return


    def kirjutaWiki(self,point,misc='ident',tiitel='ZWIKI',start='WikiStart',toc='',palju=''):
	self.generateID()
	if toc:
		self.kirjutaItem(toc,parameters='wikifolder',tiitel=tiitel,originalID=point.getId(),originalOwner=point.getOwnerTuple()[1],realObject=point)
	else:
		self.kirjutaItem(self.organization,tiitel=tiitel,parameters='wikifolder')
	w_metadata,w_organizations,w_resources = self.kirjutaManifest()
        organization = self.dom.createElement('organization')
        organization.setAttribute('identifier',misc+str(self.idnumber))
        w_organizations.appendChild(organization)
	#kirjutame esieme wiki-lehe 
	self.generateID()
	try:
		item = self.kirjutaItem(organization,parameters='ZWiki',tiitel=getattr(point,start).name())
	except:
		start = 'WikiAvaLeht'
		item = self.kirjutaItem(organization,parameters='ZWiki',tiitel=getattr(point,'WikiAvaLeht').name())
	wnimi = self.binarydata.storeData(getattr(point, start),'wiki') 
	self.kirjutaResource(w_resources,'wikipage', wnimi)

	self.indekseeriWikid(point)
	self.wikilevel = 1
	if palju:
		self.otsiWikiLapsed(point,w_resources,item,start,palju)
	else:
		self.otsiWikiLapsed(point,w_resources,item,start)
	return

    def kirjutaKasutajaWiki(self,kasutajad,start='WikiStart'):
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='KASUTAJA WIKI')
	w_metadata,w_organizations,w_resources = self.kirjutaManifest()
        self.generateID()
	for kasutaja in kasutajad:
		uname = kasutaja.get_uname()
		try:
			pp = getattr(self.iva.fle_users, uname)
			point = getattr(pp.webtop, 'c'+self.kursusenr)
			wiki_organization = self.dom.createElement('organization')
			wiki_organization.setAttribute('identifier','user_'+str(uname)+'_wiki')
			self.generateID()
			try:
			        item = self.kirjutaItem(wiki_organization,tiitel=getattr(point,start).name())
			except:
				start = 'WikiAvaLeht'
				try:
					item = self.kirjutaItem(wiki_organization,tiitel=getattr(point,start).name())
				except:
					continue
			w_organizations.appendChild(wiki_organization)
		        wnimi = self.binarydata.storeData(getattr(point, start),'wiki')
		        self.kirjutaResource(w_resources,'wikipage', wnimi)
	
		        self.indekseeriWikid(point)
		        self.otsiWikiLapsed(point,w_resources,item,start)
		except:
			pass
	return

    def vCalTime(self, aeg):
	import time
	vaeg = time.localtime(aeg)
	v_aeg = ""
	v_aeg += str(vaeg[0])
	if len(str(vaeg[1])) == 1:
		v_aeg += "0" +str(vaeg[1])
	else:
		v_aeg += str(vaeg[1])
	if len(str(vaeg[2])) == 1:
		v_aeg += "0" +str(vaeg[2])
	else:
		v_aeg += str(vaeg[2])
	v_aeg += "T"
	if len(str(vaeg[3])) == 1:
		v_aeg += "0"+str(vaeg[3])
	else:
		v_aeg += str(vaeg[3])
	if len(str(vaeg[4])) == 1:
		v_aeg += "0"+str(vaeg[4])
	else:
		v_aeg += str(vaeg[4])
	if len(str(vaeg[5])) == 1:
		v_aeg += "0"+str(vaeg[5])
	else:
		v_aeg += str(vaeg[5])
	return v_aeg

    def format(self,sisend):
	temp = re.sub('\r\n',' ',sisend)
	pikkus = len(temp)
	tulem = ""
	if pikkus>60:
		abc = ""
		for taht in temp:
			abc += taht
			if len(abc)>59:
				tulem += abc
				tulem += "\r\n"
				tulem += " "
				abc = ""
		tulem += abc
		#tulem += "\r\n"
	else:
		tulem = temp
	return tulem

    def kirjutaEvent(self,point,omanik='mina',kat='kursus'):
	tulem = ""
	for syndmus in point.objectValues():
		tulem += "BEGIN:VEVENT\r\n"
		tulem += "DTSTART:"+self.vCalTime(syndmus.algus)+"\r\n"
		tulem += "DTEND:"+self.vCalTime(syndmus.lopp)+"\r\n"
		tulem += "N:"+omanik+"\r\n"
		tulem += "DESCRIPTION:"+self.format(syndmus.kysiPikk())+"\r\n"
		#tulem += "SUMMARY:"+self.format(syndmus.lyhi)+"\r\n"
		tulem += "STATUS:"+str(syndmus.olek)+"\r\n"
		tulem += "CUTYPE:"+kat+"\r\n"
		tulem += "URL:"+syndmus.viide+"\r\n"
		tulem += "X-PROPERTY;VALUE=NAME:"+self.format(syndmus.nimi)+"\r\n"
#		tulem += "X-COMPONENT;VALUE=NAME:"+self.format(oma)+"\r\n"
		tulem += "RESOURCES:"+self.format(syndmus.siseviide)+"\r\n"
		tulem += "END:VEVENT\r\n"
	return tulem 

    def has_events(self,point):
	for syndmus in point.objectValues():
		return  1
	return 0 

    def kirjutavCal(self,point,omanik,kat,organiz='', resour=''):
	if organiz == '':
		organiz = self.organization
	if resour == '':
		resour = self.resources
	if self.has_events(point):
		vCal = "BEGIN:VCALENDAR\r\n"
		vCal += "METHOD:PUBLISH\r\n"
		vCal += "VERSION:2.0\r\n"
		vCal += "PRODID:IVA\r\n"
		vCal += self.kirjutaEvent(point,omanik,kat)
		vCal += "END:VCALENDAR\r\n"
		nimi = self.binarydata.storeData(vCal,'vcal','.ics')
	        self.generateID()
	        self.kirjutaItem(organiz,tiitel='iCalendar - '+omanik+' - syndmused',parameters='iCalendar - '+omanik+' - syndmused')
#	        self.kirjutaItem(self.organization,tiitel='iCalendar - '+omanik+' syndmused')
	        self.kirjutaResource(resour,'iCalendar',nimi)
#	        self.kirjutaResource(self.resources,'iCalendar',nimi)
	return 

    def kirjutaKasutajaSyndmus(self,kasutajad):
	self.generateID()
	self.kirjutaItem(self.organization, tiitel="KASUTAJATE SYNDMUSED",parameters="KASUTAJATE SYNDMUSED")
	s_metadata,s_organizations,s_resources = self.kirjutaManifest()
	for user in kasutajad:
		try:
		    uname = user.get_uname()
		    point = getattr(self.iva.fle_users, uname)
		    if self.has_events(point.syndmused):
			syndmus_organization = self.dom.createElement('organization')
			syndmus_organization.setAttribute('identifier','user_'+str(uname)+'_events')
			s_organizations.appendChild(syndmus_organization)
			self.kirjutavCal(point.syndmused, uname, 'INDIVIDUAL',syndmus_organization,s_resources)
		except:
		    pass
	return

    def exportMail(self,failinimi,palju=''):
        mmdoc = Document()
        mm = mmdoc.createElement('MailMessages')
        mmdoc.appendChild(mm)

        users = []
        if not palju:
                users = self.iva.fle_users.get_users()
        else:
                users = eval(palju)
        for x in users:
                if not hasattr(x, 'kirjad'):
                        continue
                point = getattr(x, 'kirjad')
                cat = mmdoc.createElement('catalog')
                cat.setAttribute('owner', x.get_uname())
                mm.appendChild(cat)
                for kiri in point.objectValues():
                        mess = mmdoc.createElement('message')
                        mess.setAttribute('read',str(kiri.kasLoetud()))
                        if kiri.kasOmaKoopia():
                                mess.setAttribute('owncopy','1')
                        cat.appendChild(mess)
                        title = mmdoc.createElement('title')
			tekst = kiri.kysiPealkiri()
			tekst = re.sub(']]>',']] >',tekst)
			# decode and then encode
			try:
				tekst = tekst.decode('utf-8')
			except UnicodeDecodeError:
				tekst = tekst.decode('iso-8859-15')
			tekst = tekst.encode('utf-8')
			title.appendChild(mmdoc.createCDATASection(strip_non_xml(tekst)))
                        mess.appendChild(title)

                        body = mmdoc.createElement('body')
			tekst = kiri.kysiSisu()
			tekst = re.sub(']]>',']] >',tekst)
			try:
				tekst = tekst.decode('utf-8')
			except UnicodeDecodeError:
				tekst = tekst.decode('iso-8859-13')
			tekst = tekst.encode('utf-8')
			body.appendChild(mmdoc.createCDATASection(strip_non_xml(tekst)))
                        mess.appendChild(body)

                        sender = mmdoc.createElement('sender')
                        sender.appendChild(mmdoc.createTextNode(str(kiri.kysiSaatja())))
                        mess.appendChild(sender)

                        receiver = mmdoc.createElement('receiver')
                        receiver.appendChild(mmdoc.createTextNode(str(kiri.saaja)))
                        mess.appendChild(receiver)

                        date = mmdoc.createElement('date')
                        date.appendChild(mmdoc.createTextNode(str(kiri.kysiAeg())))
                        mess.appendChild(date)

        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
#        mmdoc.dump = Dump()
#        mmdoc.writexml(mmdoc.dump)
#        zip.writestr(zipfile.ZipInfo("messages.xml"),mmdoc.dump.getdata())
	zip.writestr(zipfile.ZipInfo("messages.xml"),mmdoc.toprettyxml())
        zip.close()
        return

    def exportCourseCategories(self, failinimi):
	""" export course categories """
	cm = self.iva.courses
        mmdoc = Document()
        mm = mmdoc.createElement('CourseCats')
        mmdoc.appendChild(mm)

	course_cat = cm.cCategories
	c = mmdoc.createElement('categories')
	c_data = mmdoc.createTextNode(str(course_cat))
	c.appendChild(c_data)
	mm.appendChild(c)
	
	if zipfile.is_zipfile(failinimi):
		zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
	else:
		zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	zip.writestr(zipfile.ZipInfo("course_cat.xml"),mmdoc.toprettyxml())
	zip.close()
	return

    def exportAffiliations(self, failinimi):
	""" export affiliation codes """
	mmdoc = Document()
	mm = mmdoc.createElement('Affiliations')
	mmdoc.appendChild(mm)

	e = self.iva.fle_users.getAffiliations()
	for x in e:
		aff = mmdoc.createElement('affiliation')
		aff_data = mmdoc.createTextNode(x)
		aff.appendChild(aff_data)
		mm.appendChild(aff)
	if zipfile.is_zipfile(failinimi):
		zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
	else:
		zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	zip.writestr(zipfile.ZipInfo("affiliations.xml"),mmdoc.toprettyxml())
	zip.close()
	return

    def exportServerSettings(self, failinimi):
	""" export iva settings """
	mmdoc = Document()
	mm = mmdoc.createElement('Settings')
	mmdoc.appendChild(mm)

	# allow user registration
	auto = mmdoc.createElement('auto_register')
	auto_data = mmdoc.createTextNode(str(self.iva.get_allow_autoregister()))
	auto.appendChild(auto_data)
	mm.appendChild(auto)
	
	# quota
	quota = mmdoc.createElement('quota')
	quota_data = mmdoc.createTextNode(str(self.iva.webtop_quota))
	quota.appendChild(quota_data)
	mm.appendChild(quota)
	
	# quota amount
	quota_amount = mmdoc.createElement('quota_amount')
	quota_amount_data = mmdoc.createTextNode(str(self.iva.webtop_quota_amount))
	quota_amount.appendChild(quota_amount_data)
	mm.appendChild(quota_amount)
	
	# mailhost & port
	mail_host = mmdoc.createElement('mail_host')
	mail_host.setAttribute('port', str(self.iva.MailHost.smtp_port))
	mail_host_data = mmdoc.createTextNode(str(self.iva.MailHost.smtp_host))
	mail_host.appendChild(mail_host_data)
	mm.appendChild(mail_host)
	
	# mail from
	mail_from = mmdoc.createElement('mail_from')
	mail_from_data = mmdoc.createTextNode(str(self.iva.MFROM))
	mail_from.appendChild(mail_from_data)
	mm.appendChild(mail_from)
	
	# default language
	def_lang = mmdoc.createElement('default_language')
	def_lang_data = mmdoc.createTextNode(str(self.iva.get_default_language()))
	def_lang.appendChild(def_lang_data)
	mm.appendChild(def_lang)
	
	# must change password
	def_change = mmdoc.createElement('force_change')
	def_change_data = mmdoc.createTextNode(str(self.iva.def_passwd))
	def_change.appendChild(def_change_data)
	mm.appendChild(def_change)
	
	# cannot change affiliation
	def_aff = mmdoc.createElement('deny_affiliation_change')
	def_aff_data = mmdoc.createTextNode(str(self.iva.def_not_aff))
	def_aff.appendChild(def_aff_data)
	mm.appendChild(def_aff)
	
	# cannot change password
	def_password = mmdoc.createElement('deny_password_change')
	def_password_data = mmdoc.createTextNode(str(self.iva.def_not_change))
	def_password.appendChild(def_password_data)
	mm.appendChild(def_password)

	if zipfile.is_zipfile(failinimi):
		zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
	else:
		zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	zip.writestr(zipfile.ZipInfo("settings.xml"),mmdoc.toprettyxml())
	zip.close()
	return

    def exportKodutood(self, point,failinimi,path):
	# expordime kodutd
	kt_doc = Document()
	kt = kt_doc.createElement('Assignments')
	kt_doc.appendChild(kt)
	kt.setAttribute('identifier','IVA')
	kt.setAttribute('version','1')
	for kodu in point.listAssignments():
		too = kt_doc.createElement('Assignment')
		too.setAttribute('originalID',kodu.get_id())
		kt.appendChild(too)

		tyyp = kt_doc.createElement('type')
		tyyp_data = kt_doc.createTextNode(str(kodu.tyyp))
		tyyp.appendChild(tyyp_data)
		too.appendChild(tyyp)

		pkiri = kt_doc.createElement('title')
		pkiri_data = kt_doc.createTextNode(str(kodu.getTitle()))
		pkiri.appendChild(pkiri_data)
		too.appendChild(pkiri)

		kirjeldus = kt_doc.createElement('description')
		kirjeldus_data = kt_doc.createTextNode(str(kodu.kirjeldus))
		kirjeldus.appendChild(kirjeldus_data)
		too.appendChild(kirjeldus)
		
		punkt = kt_doc.createElement('points')
		punkt_data = kt_doc.createTextNode(str(kodu.getPoints()))
		punkt.appendChild(punkt_data)
		too.appendChild(punkt)
		try:
			resour = kt_doc.createElement('resource')
			resour_data = kt_doc.createTextNode(str(kodu.juhend))
			resour.appendChild(resour_data)
			too.appendChild(resour)
		except:
			pass
		try:
			aeg = kt_doc.createElement('end')
			aeg_data = kt_doc.createTextNode(str(kodu.loppaeg))
			aeg.appendChild(aeg_data)
			too.appendChild(aeg)
		except:
			pass
		try:
			grupp = kt_doc.createElement('groups')
			for abc in kodu.getGroups():
				gr = kt_doc.createElement('group')
				grupp_data = kt_doc.createTextNode(str(abc))
				gr.appendChild(grupp_data)
				grupp.appendChild(gr)
			too.appendChild(grupp)
		except:
			pass
		try:
			test = kt_doc.createElement('test')
			test_data = kt_doc.createTextNode(str(kodu.testiID))
			test.appendChild(test_data)
			too.appendChild(test)
		except:
			pass

	self.generateID()
	self.kirjutaItem(self.organization,tiitel='Assignments',parameters='Assignments')
	self.kirjutaResource(self.resources,'assignments','assignments.xml','assignments.xml')
        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        kt_doc.dump = Dump()
        kt_doc.writexml(kt_doc.dump)
        zip.writestr(zipfile.ZipInfo(path+"assignments.xml"),kt_doc.dump.getdata())
        zip.close()

	return


    def exportPajad(self,failinimi,path,startonly=0):
	self.generateID()
	TP = Document()
	MP = Document()

	kala = Exporter(self.iva)
	tp_elem = TP.createElement('KnowledgeBuilding')
	for ctx in self.kursus.get_children("CourseContext"):
		tp_elem.appendChild(kala.exportContext(ctx,startonly))

	TP.appendChild(tp_elem)
	mp_elem = MP.createElement('Jamming')
        try:
            #for c in courses.get_children('Course'):
            for js in self.kursus.get_child('jamming').get_children('JamSession'):
		mp_elem.appendChild(kala.exportJamSession(self.kursus, js,startonly))
	except:
		pass
	MP.appendChild(mp_elem)
	self.kirjutaItem(self.organization,tiitel='TEADMUSPAJA',parameters='TEADMUSPAJA')
	self.kirjutaResource(self.resources,'teadmuspaja','teadmuspaja.xml','teadmuspaja.xml')
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='MEEDIAPAJA',parameters='MEEDIAPAJA')
	self.kirjutaResource(self.resources,'meediapaja','meediapaja.xml','meediapaja.xml')

        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        TP.dump = Dump()
        MP.dump = Dump()
        TP.writexml(TP.dump)
        MP.writexml(MP.dump)
        zip.writestr(zipfile.ZipInfo(path+"teadmuspaja.xml"),TP.dump.getdata())
        zip.writestr(zipfile.ZipInfo(path+"meediapaja.xml"),MP.dump.getdata())
        for name in kala.binarydata.names:
            zip.writestr(
                zipfile.ZipInfo(path+name),
                str(kala.binarydata.getData(name)))
	zip.close()
	return

    def exportQTI(self,failinimi,path,teacherExporting=0):
	# function for going all necessary to export tests
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='QTI',parameters='QTI')
	self.kirjutaResource(self.resources,'imsqti_xmlv1p1','qti.xml','qti.xml')
	element = self.looTestiFail()
	self.kirjutaTestid(element,teacherExporting=teacherExporting)
	self.kirjutaTestidZipi(failinimi,path)

    def looTestiFail(self):
	self.generateID()
	self.qti = Document()
	self.qtibin = DataTable()
	self.qtiroot = self.qti.createElement("questestinterop")
	self.qtiroot.setAttribute('xmlns','http://www.imsglobal.org/xsd/ims_qtiasiv1p2')
	self.qtiroot.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	self.qtiroot.setAttribute('xsi:schemaLocation','http://www.imsglobal.org/xsd/ims_qtiasiv1p2 http://www.imsglobal.org/xsd/ims_qtiasiv1p2.xsd')
	self.qti.appendChild(self.qtiroot)
	return self.qtiroot

    def kirjutaTestidZipi(self,failinimi,path=''):
	if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	self.qti.dump = Dump()
	self.qti.writexml(self.qti.dump)
	zip.writestr(zipfile.ZipInfo(path+"qti.xml"),self.qti.dump.getdata())
        for name in self.qtibin.names:
            zip.writestr(
                zipfile.ZipInfo(path+name),
                str(self.qtibin.getData(name)))
        zip.close()

	return

    def testiPilt(self,vanem, varamu):
	if varamu.pilt is not None:
	        mat_pilt = self.qti.createElement('matimage')
	        name = self.qtibin.storeData(varamu.pilt,'qti')
	        mat_pilt.setAttribute('uri',name)
		vanem.appendChild(mat_pilt)
	return vanem

    def testiViide(self,vanem, varamu):
	if varamu.viiteURL != '':
             matem = self.qti.createElement('matemtext')
             matem.setAttribute('uri',varamu.viiteURL)
             matem.appendChild(self.qti.createTextNode(varamu.viiteTekst))
             vanem.appendChild(matem)
	return vanem

    def testiKirjeldavTekst(self,vanem,varamu):
	if varamu.kirjeldavTekst != '':
             komm = self.qti.createElement('qticomment')
             komm.appendChild(self.qti.createTextNode(varamu.kirjeldavTekst))
             vanem.appendChild(komm)
	return vanem

    def testiItem(self,vanem,varamu):
        elem = self.qti.createElement('item')
        elem.setAttribute('ident',varamu.get_id())
	elem.setAttribute('title',varamu.meta_type)
        vanem.appendChild(elem)
	return elem 

    def exportUserResponses(self,vanem,hoidla,users=''):
        if not users:
                users = self.kursus.get_all_users()
        else:
                users = eval(users)
        for x in users:
		print "\nuser:", x.get_uname()
                try:
                        tmpx = getattr(self.iva.fle_users, x.get_uname()).webtop
                        tmpy = getattr(tmpx, 'c'+self.kursus.get_id())
			tmpz = getattr(tmpy, 'testivastused').__of__(tmpy)
                        z = getattr(tmpz.aq_self.aq_base, hoidla.get_id())
                except AttributeError:
                        continue
                elem = self.qti.createElement('response')
                elem.setAttribute('owner',x.get_uname())
                for i in z.aq_self.objectValues():
                        ver = self.qti.createElement('version')
                        ver.setAttribute('id',str(i.get_id()))
                        try:
                                ver.setAttribute('comment',str(i.annaKoguKommentaar()))
                        except AttributeError:
                                pass
                        elem.appendChild(ver)
                        for j in i.objectValues():
                                yl = self.qti.createElement('yl')
                                yl.setAttribute('id',j.get_id())
                                try:
                                        if j.annaOpetajaPunktid() is not None:
                                                yl.setAttribute('score',str(j.annaOpetajaPunktid()))
                                except AttributeError:
                                        pass
                                try:
                                        yl.setAttribute('comment',str(j.annaOpetajaKommentaar()))
                                except AttributeError:
                                        pass
                                try:
                                        if type(j.pakutud())==types.ListType:
                                                yl.setAttribute('type','List')
                                        yl.appendChild(self.qti.createTextNode(str(j.pakutud())))
                                except AttributeError:
					#print z.absolute_url(), i.absolute_url(), j, x.get_uname(), j.absolute_url()
					print "j.pakutud()", dir(j)
                                        pass
                                ver.appendChild(yl)
                vanem.appendChild(elem)
        return

    def kirjutaTestid(self,vanem,testinimi='',users='',teacherExporting=0):
	if testinimi != '':
		ainult_yks_test = 1
	else:
		ainult_yks_test = 0
        qticomment = self.qti.createElement("qticomment")
        qticomment_data = self.qti.createTextNode('Here is a set of questions and tests from IVA')
        qticomment.appendChild(qticomment_data)
        vanem.appendChild(qticomment)
        # export all tests and questions within course
	for hoidla in self.kursus.testid.objectValues():
	 if hoidla.get_id() == testinimi or not ainult_yks_test:
	  sektion = self.qti.createElement('section')
	  sektion.setAttribute('title',str(hoidla.pealkiri))
	  sektion.setAttribute('ident',str(hoidla.get_id()))
          sektion.setAttribute('type',str(hoidla.kysiTyyp()))
          sektion.setAttribute('randomize',str(hoidla.kasKysimusteJuhuslikJarjekord()))
          sektion.setAttribute('answers',str(hoidla.kysiVastusteNahtavus()))
          sektion.setAttribute('open',str(hoidla.avatudTaitmiseks))

          md = self.qti.createElement('metadata')
          sektion.appendChild(md)

          tl = self.qti.createElement('timelimit')
          tl.setAttribute('repeat',str(hoidla.koigiLuba.kordadeArv))
          tl.setAttribute('start',str(hoidla.koigiLuba.algusAeg))
          tl.setAttribute('end',str(hoidla.koigiLuba.loppAeg))
          md.appendChild(tl)

          grs = self.qti.createElement('groups')
          md.appendChild(grs)
          for x in hoidla.grupiLoad.objectValues():
                  gr = self.qti.createElement('group')
                  gr.setAttribute('repeat',str(x.kordadeArv))
                  gr.setAttribute('start',str(x.algusAeg))
                  gr.setAttribute('end',str(x.loppAeg))
                  gr.setAttribute('name',str(x.id))
                  grs.appendChild(gr)

          prs = self.qti.createElement('persons')
          md.appendChild(prs)
          for x in hoidla.isikuLoad.objectValues():
                  pr = self.qti.createElement('person')
                  pr.setAttribute('repeat',str(x.kordadeArv))
                  pr.setAttribute('start',str(x.algusAeg))
                  pr.setAttribute('end',str(x.loppAeg))
                  pr.setAttribute('name',str(x.id))
                  prs.appendChild(pr)

          desc = self.qti.createElement('description')
          desc.appendChild(self.qti.createTextNode(str(hoidla.annaKirjeldus())))
          md.appendChild(desc)

          uresp = self.qti.createElement('userresponses')
          sektion.appendChild(uresp)

	  if not teacherExporting:
	          self.exportUserResponses(uresp,hoidla,users)

	  #print hoidla.get_id()
	  for yled in hoidla.objectValues():
		#print "->>"+yled.get_id()
		#print yled.get_id()+" - "+ yled.meta_type
		tyyp = yled.meta_type
        	if tyyp=='ValikYlesanne':
                        elem = self.testiItem(sektion,yled)
			self.testiKirjeldavTekst(elem,yled)
			present = self.qti.createElement('presentation')
			elem.appendChild(present)
			flo = self.qti.createElement('flow')
			present.appendChild(flo)
			mat = self.qti.createElement('material')
			flo.appendChild(mat)
			mattext = self.qti.createElement('mattext')
			mattext.appendChild(self.qti.createTextNode(yled.kysimus))
			mat.appendChild(mattext)
			
			self.testiViide(mat,yled)
			self.testiPilt(mat,yled)

			resp_lid = self.qti.createElement('response_lid')
			resp_lid.setAttribute('ident',yled.get_id())
			resp_lid.setAttribute('rcardinality',"Single")
			flo.appendChild(resp_lid)

			render = self.qti.createElement('render_choice')
			resp_lid.appendChild(render)
			flow_l = self.qti.createElement('flow_label')
			render.appendChild(flow_l)
			
			resp_lab = self.qti.createElement('response_label')
			resp_lab.setAttribute('ident','T')
			flow_l.appendChild(resp_lab)
                        mat2 = self.qti.createElement('material')
                        resp_lab.appendChild(mat2)
                        mattext2 = self.qti.createElement('mattext')
                        mattext2.appendChild(self.qti.createTextNode('True'))
                        mat2.appendChild(mattext2)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','F')
                        flow_l.appendChild(resp_lab)
                        mat2 = self.qti.createElement('material')
                        resp_lab.appendChild(mat2)
                        mattext2 = self.qti.createElement('mattext')
                        mattext2.appendChild(self.qti.createTextNode('False'))
                        mat2.appendChild(mattext2)


			resproc = self.qti.createElement('resprocessing')
			elem.appendChild(resproc)
			out = self.qti.createElement('outcomes')
			resproc.appendChild(out)
			muut = self.qti.createElement('decvar')
			muut.setAttribute('vartype','Integer')
			muut.setAttribute('maxvalue',str(yled.normPunktid))
			out.appendChild(muut)

			kond = self.qti.createElement('respcondition')
			kond.setAttribute('title','Correct')
			resproc.appendChild(kond)
			kond_var = self.qti.createElement('conditionvar')
			kond.appendChild(kond_var)
			varequal = self.qti.createElement('varequal')
			varequal.setAttribute('respident',yled.get_id())
			if yled.vastus:
				varequal.appendChild(self.qti.createTextNode('T'))
			else:
				varequal.appendChild(self.qti.createTextNode('F'))
 			kond_var.appendChild(varequal)

			setvar = self.qti.createElement('setvar')
			setvar.setAttribute('action','Add')
			setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			pass
		if tyyp=='OigeTekstivastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_str')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
                        flo.appendChild(resp_lid)

                        render = self.qti.createElement('render_fib')
			render.setAttribute('fibtype','String')
			render.setAttribute('encoding','UTF_8')
                        resp_lid.appendChild(render)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)
                        
			kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
                        for abc in yled.variandid:
                                varequal = self.qti.createElement('varequal')
                                varequal.setAttribute('respident',yled.get_id())
                                varequal.appendChild(self.qti.createTextNode(str(abc)))
                                kond_var.appendChild(varequal)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			
			pass
        	if tyyp=='YksikvalikYlesanne':
                        elem = self.testiItem(sektion,yled)
			self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

			self.testiViide(mat,yled)
			self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_lid')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
                        flo.appendChild(resp_lid)

                        render = self.qti.createElement('render_choice')
			render.setAttribute('shuffle','Yes')
                        resp_lid.appendChild(render)
			i=0
			for abc in yled.valikud:
	                        resp_lab = self.qti.createElement('response_label')
	                        resp_lab.setAttribute('ident',str(i))
	                        render.appendChild(resp_lab)
				flow_mat = self.qti.createElement('flow_mat')
				resp_lab.appendChild(flow_mat)
	                        mat2 = self.qti.createElement('material')
	                        flow_mat.appendChild(mat2)
	                        mattext2 = self.qti.createElement('mattext')
	                        mattext2.appendChild(self.qti.createTextNode(abc))
	                        mat2.appendChild(mattext2)
				i=i+1

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
                        varequal = self.qti.createElement('varequal')
                        varequal.setAttribute('respident',yled.get_id())
			varequal.appendChild(self.qti.createTextNode(str(yled.oigeValik)))
			kond_var.appendChild(varequal)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			i=0
			if not hasattr(yled,'selgitused'):
				selgitused = []
			for abc in yled.selgitused:
				itemfeed = self.qti.createElement('itemfeedback')
				itemfeed.setAttribute('ident',str(i))
				elem.appendChild(itemfeed)
				flow_m = self.qti.createElement('flow_mat')
				itemfeed.appendChild(flow_m)
				mat = self.qti.createElement('material')
				flow_m.appendChild(mat)
				mattext = self.qti.createElement('mattext')
				mattext.appendChild(self.qti.createTextNode(abc))
				mat.appendChild(mattext)
				i=i+1
			pass
        	if tyyp=='TekstivastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_str')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Ordered")
                        flo.appendChild(resp_lid)
			
                        render = self.qti.createElement('render_fib')
                        render.setAttribute('fibtype','String')
                        render.setAttribute('enconding','UTF_8')
			render.setAttribute('prompt','Box')
                        resp_lid.appendChild(render)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)
			pass
        	if tyyp=='MitmikvalikYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_lid')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Multiple")
                        flo.appendChild(resp_lid)
			
                        render = self.qti.createElement('render_choice')
                        render.setAttribute('shuffle','Yes')
                        resp_lid.appendChild(render)
                        i=0
                        for abc in yled.valikud:
                                resp_lab = self.qti.createElement('response_label')
                                resp_lab.setAttribute('ident',str(i))
                                render.appendChild(resp_lab)
                                flow_mat = self.qti.createElement('flow_mat')
                                resp_lab.appendChild(flow_mat)
                                mat2 = self.qti.createElement('material')
                                flow_mat.appendChild(mat2)
                                mattext2 = self.qti.createElement('mattext')
                                mattext2.appendChild(self.qti.createTextNode(abc))
                                mat2.appendChild(mattext2)
                                i=i+1

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
			for abc in yled.oigedValikud:
	                        varequal = self.qti.createElement('varequal')
	                        varequal.setAttribute('respident',yled.get_id())
	                        varequal.appendChild(self.qti.createTextNode(str(abc)))
	                        kond_var.appendChild(varequal)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
                        i=0
                        for abc in yled.selgitused:
                                itemfeed = self.qti.createElement('itemfeedback')
                                itemfeed.setAttribute('ident',str(i))
                                elem.appendChild(itemfeed)
                                flow_m = self.qti.createElement('flow_mat')
                                itemfeed.appendChild(flow_m)
                                mat = self.qti.createElement('material')
                                flow_m.appendChild(mat)
                                mattext = self.qti.createElement('mattext')
                                mattext.appendChild(self.qti.createTextNode(abc))
                                mat.appendChild(mattext)
                                i=i+1

			pass
        	if tyyp=='ArvuvahemikuliseVastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_num')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
			resp_lid.setAttribute('numtype','Decimal')
                        flo.appendChild(resp_lid)

                        render = self.qti.createElement('render_fib')
			render.setAttribute('fibtype','Decimal')
			render.setAttribute('prompt','Box')
                        resp_lid.appendChild(render)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
			komm = self.qti.createElement('qticomment')
			komm.appendChild(self.qti.createTextNode(str(yled.arvutusTyyp)))
			out.appendChild(komm)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
			varless = self.qti.createElement('vargte')
			varless.setAttribute('respident',yled.get_id())
			varless.appendChild(self.qti.createTextNode(str(yled.alamPiir)))
			kond_var.appendChild(varless)
                        varequal = self.qti.createElement('varequal')
                        varequal.setAttribute('respident',yled.get_id())
                        varequal.appendChild(self.qti.createTextNode(str(yled.oigeVastus)))
                        kond_var.appendChild(varequal)
			varover = self.qti.createElement('varlte')
			varover.setAttribute('respident',yled.get_id())
			varover.appendChild(self.qti.createTextNode(str(yled.ylemPiir)))
			kond_var.appendChild(varover)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)

			pass
        	if tyyp=='ProtsentYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        points = self.qti.createElement('points')
                        points_data = self.qti.createTextNode(str(yled.normPunktid))
                        points.appendChild(points_data)
                        elem.appendChild(points)

                        searching = self.qti.createElement('searching')
                        searching.appendChild(self.qti.createTextNode(str(yled.kysitav)))
                        elem.appendChild(searching)

                        solvent = self.qti.createElement('solvent')     #lahus
                        min = self.qti.createElement('min')
                        min.appendChild(self.qti.createTextNode(str(yled.lahustiAlamPiir)))
                        max = self.qti.createElement('max')
                        max.appendChild(self.qti.createTextNode(str(yled.lahustiYlemPiir)))
                        names = self.qti.createElement('names')
                        names.appendChild(self.qti.createTextNode(str(yled.lahustiTekst)))
                        stype = self.qti.createElement('type')
                        stype.appendChild(self.qti.createTextNode(str(yled.lahustiYhik)))

                        solvent.appendChild(min)
                        solvent.appendChild(max)
                        solvent.appendChild(names)
                        solvent.appendChild(stype)

                        elem.appendChild(solvent)

                        soluble = self.qti.createElement('soluble')     #aine
                        min  = self.qti.createElement('min')
                        min.appendChild(self.qti.createTextNode(str(yled.aineAlamPiir)))
                        max = self.qti.createElement('max')
                        max.appendChild(self.qti.createTextNode(str(yled.aineYlemPiir)))
                        names = self.qti.createElement('names')
                        names.appendChild(self.qti.createTextNode(str(yled.aineTekst)))
                        stype = self.qti.createElement('type')
                        stype.appendChild(self.qti.createTextNode(str(yled.aineYhik)))

                        soluble.appendChild(min)
                        soluble.appendChild(max)
                        soluble.appendChild(names)
                        soluble.appendChild(stype)

                        elem.appendChild(soluble)

                        accuracy = self.qti.createElement('accuracy')
                        accuracy.appendChild(self.qti.createTextNode(str(yled.vastuseTapsusProtsent)))
                        elem.appendChild(accuracy)

                        scoring = self.qti.createElement('scoring')
                        scoring.appendChild(self.qti.createTextNode(str(yled.arvutusTyyp)))
                        elem.appendChild(scoring)

        	if tyyp=='VastavusYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

			resp_grp = self.qti.createElement('response_grp')
                        resp_grp.setAttribute('ident',yled.get_id())
                        resp_grp.setAttribute('rcardinality',"Multiple")
                        flo.appendChild(resp_grp)
			render = self.qti.createElement('render_choice')
			render.setAttribute('shuffle','Yes')
			resp_grp.appendChild(render)
			i=0
			krupp = ''
			for abc in yled.vastused:
				resp_lab = self.qti.createElement('response_label')
				ident = 'p'+str(i)
				if krupp != '':
					krupp = krupp+','
				krupp = krupp + ident
				resp_lab.setAttribute('ident',ident)
				resp_lab.setAttribute('rshuffle','Yes')
				resp_lab.setAttribute('rrange','Exact')
				render.appendChild(resp_lab)
				rmat = self.qti.createElement('material')
				resp_lab.appendChild(rmat)
				rmattext = self.qti.createElement('mattext')
				rmattext.setAttribute('texttype','text/plain')
				rmattext.appendChild(self.qti.createTextNode(abc))
				rmat.appendChild(rmattext)
				i=i+1
			i=0
			for abc in yled.kysimused:
				resp_lab = self.qti.createElement('response_label')
				resp_lab.setAttribute('ident','v'+str(i))
				resp_lab.setAttribute('match_max','1')
				resp_lab.setAttribute('match_group',krupp)
				resp_lab.setAttribute('rshuffle','Yes')
				resp_lab.setAttribute('rrange','Exact')
				render.appendChild(resp_lab)
                                rmat = self.qti.createElement('material')
                                resp_lab.appendChild(rmat)
                                rmattext = self.qti.createElement('mattext')
                                rmattext.setAttribute('texttype','text/plain')
                                rmattext.appendChild(self.qti.createTextNode(abc))
                                rmat.appendChild(rmattext)
				i=i+1

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
			jah = self.qti.createElement('and')
			kond_var.appendChild(jah)
			i=0
			for abc in yled.vastused:
				varsub = self.qti.createElement('varsubset')
				varsub.setAttribute('respident',yled.get_id())
				varsub.setAttribute('setmatch','Exact')
				varsub.appendChild(self.qti.createTextNode('v'+str(i)+','+'p'+str(i)))
				jah.appendChild(varsub)
				i=i+1
                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
                        kond.appendChild(setvar)
			
			pass
	  vanem.appendChild(sektion)
	return

