# -*- coding: utf-8
# Copyright 2001, 2002 by IVA Team and contributors
#
# This file is part of IVA.
#
# IVA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IVA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import AccessControl
import OFS, Globals
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from common import add_dtml
from ValikTest import ValikTest
from TraversableWrapper import Traversable
from Cruft import Cruft

class TestiHaldur(
    OFS.Folder.Folder,
    Persistent,
    AccessControl.Role.RoleManager,
    Traversable,
    Cruft
    ):

    def __init__(self):
	""
	self.testinr=0
       
    
    def lisaValikTest(self, REQUEST):
	""" Lisab valiktesti """
	self.testinr = self.testinr + 1
	while hasattr(self.aq_self, 'test'+str(self.testinr)):
		self.testinr = self.testinr + 1
	vt=ValikTest()
	testinimi='test'+str(self.testinr)
	vt.id=testinimi
	self._setObject(testinimi, vt)
	REQUEST.RESPONSE.redirect('testihaldus')
       
    def kysiTestinr(self):
       "teatab viiamatise testinumbri"
       return self.testinr

    def salvestusAsukoht(self, REQUEST, testinimi='nimetu'):
       "Koht testi tulemuste salvestamiseks"
       kasutajajuur=getattr(self.fle_root().fle_users,\
                   str(REQUEST.AUTHENTICATED_USER))
       kasutaja=getattr(kasutajajuur.webtop,\
          'c'+kasutajajuur.get_jooksev_kursus())
       if not hasattr(kasutaja, 'testid'):
          kasutaja.manage_addProduct['OFSP'].manage_addFolder('testid')
          kasutaja.testid.id='testid'
       if not hasattr(kasutaja.testid, testinimi):
          kasutaja.testid.manage_addProduct['OFSP'].manage_addFolder(testinimi)
          testikataloog=getattr(kasutaja.testid, testinimi)
          testikataloog.variandinr=0
       testikataloog=getattr(kasutaja.testid, testinimi)
       #return self.get_url_to_object(testikataloog)
       return testikataloog
       
    def paigutaTestiVastus(self, REQUEST, vastus):
       "Paigutab variandi uue id alla"
       k=self.salvestusAsukoht(REQUEST, vastus.testiID)
       k.variandinr=k.variandinr+1
       #vastus=ValikTest()
       k._setObject("variant"+str(k.variandinr), vastus)
       return str(k.variandinr)

